/*  this is 
a comment
*/


create sequence pgr_rid_s start 1 cache 1;
create sequence pgr_fid_s start 1 cache 1;



create table pgr_lsite (
        pgr_sid            int4	not null,
	pgr_sessionid      int4 default 0
); 


create table pgr_flow_template (
	pgr_gfid	int8	not null,
	pgr_optype	varchar(2),
	pgr_when	datetime,
	pgr_username	varchar(30),
	pgr_flow_flag	char(1)
);



create table pgr_qryengine_log (
        pgr_sid         int4	not null,
        tablename       varchar(50),
	pgr_gfid	int8	not null,
	pgr_grid	int8    not null,
        pgr_optype      varchar(2),
        pgr_when        datetime,
        pgr_username    varchar(30),
	qry_result	text
);



create table pgr_hosts (
        host		varchar(50)	not null,
	domain		varchar(50)	not null,
        site            int4		not null,
        port            int2		default 5432,
	CONSTRAINT pgr_hosts_key PRIMARY KEY (site)
); 

       
create table  pgr_tables (
	tablename 	varchar(50),
	permissions   	varchar(10)	default 'RWLP',
        flow_eq_filter  bool            default false,
	encrypt         varchar(10)     default 'NO',
        resolv_site     int4		default 1,
	resolver 	varchar(20)	default 'NO',
	history         bool 		default true,
	silent 		bool		default true,
	monitor		bool		default false,
	locked		bool		default false,
	CONSTRAINT pgr_tables_key PRIMARY KEY (tablename)
);


create table pgr_tables_permissions (
	id		int2,
	code		varchar(10),
	description	varchar(255)
);

insert into pgr_tables_permissions values (1,'ROT','Read Only Table');
insert into pgr_tables_permissions values (2,'RWT','Read-Write Table');
insert into pgr_tables_permissions values (3,'RWLP','Read-Write Local Partitions');




create table pgr_tables_resolver (
	id		int2,
	code		varchar(10),
	description     varchar(255)
);

insert into pgr_tables_resolver values (1,'NO','No Conflict Resolution');
insert into pgr_tables_resolver values (2,'1SO','One Site Only');
insert into pgr_tables_resolver values (3,'FSO','First Site Only');
insert into pgr_tables_resolver values (4,'FTO','First Transactions Only');
insert into pgr_tables_resolver values (5,'FTO-MP','First Transactions Only - Master Priority ');
insert into pgr_tables_resolver values (6,'FTS','First Transactions Site');
insert into pgr_tables_resolver values (7,'FTS-MP','First Transactions Site - Master Priority ');
insert into pgr_tables_resolver values (8,'TS','Time Stamp');
insert into pgr_tables_resolver values (9,'TS-MP','Time Stamp - Master Priority ');


create table  pgr_distrib (
        site            int4		not null,
        tablename       varchar(50)	not null
);



create table pgr_monitor (
	tablename	varchar(50),
	I_acc		int4		default 0,
	U_acc		int4		default 0,
	D_acc		int4		default 0,
	when_occurred		datetime
);



create table pgr_threshold (
	tablename	varchar(50),
	I_acc		int4		default 2147483647,
	U_acc		int4		default 2147483647,
	D_acc		int4		default 2147483647,
	IUD_acc		int4		default 2147483647,
	max_interval	interval	default '365 00:00'
);



create table pgr_rstcheck (
        host            varchar(50)     not null,
        rst_table       varchar(50),
        row_value       text
);

