# set of remote procedures executed by pgr via tcl-DP


# this script uses others procedures:
foreach module { flushout propagation flushin resolver queryEngine updatedb history loproc} {
                source [file join $pgrdVar(pgrd_proc) $module.tcl]
                }




#---------------------------------------
proc pgrRI { dbname action } {
global pgrdVar
	set lhost $pgrdVar($dbname,lhost)
	set ldbfout $pgrdVar($dbname,pgrdlog)

	set now "        "
	puts $ldbfout "$now [clock clicks] pgrRI $dbname $action IN"
	set memFile [file join $pgrdVar($dbname,temp) pgrdVar.mem]

	set tablelist {}
	foreach table $pgrdVar($dbname,$lhost,tables) {
		lappend tablelist \'[myquote $table]\'
		}
	set tablelistString [join $tablelist ", " ]

	if {[string compare $action "disable"]==0} {
		set enabled false
		set pgrdVar($dbname,RI) disabled
		eval exec echo "set pgrdVar($dbname,RI) disabled" >> $memFile
		set query "select oid from pg_trigger where tgname ~\'^RI_\' and tgrelid in (select oid from pg_class where relname in ($tablelistString))"
		puts $ldbfout "$now [clock clicks] RI: $query"
		set pgrdVar($dbname,RIoidsList) {}
		pg_select $pgrdVar($dbname,lconn) $query RIoid {
			lappend pgrdVar($dbname,RIoidsList) $RIoid(oid)
			}
		eval exec echo "set pgrdVar($dbname,RIoidsList) $pgrdVar($dbname,RIoidsList)" >> $memFile
	} else {
		set enabled true
		set pgrdVar($dbname,RI) enabled
	}
	

	# get previous session pgrdVar values stored in memFile
	if {![info exists pgrdVar($dbname,RIoidsList)]} {
		puts $ldbfout "$now [clock clicks] reading pgrdVar values from $memFile"
		catch {source $memFile}
		if {![info exists pgrdVar($dbname,RIoidsList)]} {
			set pgrdVar($dbname,RIoidsList) {}
			}
		}

	if {[llength $pgrdVar($dbname,RIoidsList)]>0} {
		set RIoidsListString [join $pgrdVar($dbname,RIoidsList) ", "]
		set query "update pg_trigger set tgenabled=\'$enabled\' where oid in ($RIoidsListString)"
		puts $ldbfout "$now [clock clicks] RI: $query"
		set ris [query_exec $dbname $query]
		puts $ldbfout "$now [clock clicks] RI: $ris"
		} else {
		puts $ldbfout "$now [clock clicks] RI: No Referential Integrity constraints on replicated tables."
		}


	#set query "update pg_trigger set tgenabled=\'$enabled\' where tgname ~\'^RI_\' and tgrelid in (select oid from pg_class where relname in ($tablelistString))"

puts $ldbfout "$now [clock clicks] pgrRI $dbname $action OUT"
}


#---------------------------------------
# cancella i files relativi al processo di replica precedente
proc clear_old_files {dbname pgr_arg} {
global pgrdVar

        # cancella i files relativi al processo di replica precedente
	#	$PGRDATA
	#	`-- rbase
	#    	    `-- <dbname>
	#               |-- history
	#               |-- log
	#               `-- temp

	#	$PGRBOX 
	#	`-- <dbname>
	#           |-- in
	#           `-- out

	set lfout $pgrdVar(pgrdlog)
	set ldbfout $pgrdVar($dbname,pgrdlog)
	set now "        "

        # ...ripulisce <dbname>/temp 
        set fnames  [file join $pgrdVar($dbname,temp) *]
	set fnames [glob -nocomplain -- $fnames]
	set lfnames [split $fnames { }]
	# estraggo dalla lista dei files l'eventuale file pgrdVar.mem che non va cancellato
	set ind [lsearch -exact $lfnames [file join $pgrdVar($dbname,log) pgrdVar.mem]]
	set lfnames [lreplace $lfnames $ind $ind]
        puts $ldbfout "$now [clock clicks] deleting $fnames from $pgrdVar($dbname,temp) on $pgrdVar($dbname,lhost) ..."
	foreach lfname $lfnames {
		catch {file delete  $lfname}
		}
	puts $ldbfout "$now [clock clicks] $pgrdVar($dbname,temp): [glob -nocomplain -- [file join $pgrdVar($dbname,temp) *]]"

        # ripulisce <dbname>/log dai log precedenti
        set fnames  [file join $pgrdVar($dbname,log) *]
        set fnames [glob -nocomplain -- $fnames]
        set lfnames [split $fnames { }]
	# estraggo dalla lista dei files l'attuale file di log che non va cancellato
	set ind [lsearch -exact $lfnames [file join $pgrdVar($dbname,log) ${dbname}.log]]
	set lfnames [lreplace $lfnames $ind $ind]
	# estraggo dalla lista dei files LOprocs.log
	set ind [lsearch -exact $lfnames [file join $pgrdVar($dbname,log) LOprocs.log]]
	set lfnames [lreplace $lfnames $ind $ind]
        puts $ldbfout "$now [clock clicks] deleting $fnames from $pgrdVar($dbname,log) on $pgrdVar($dbname,lhost) ..."
        foreach lfname $lfnames {
                file delete  $lfname
                }
        puts $ldbfout "$now [clock clicks] $pgrdVar($dbname,log): [glob -nocomplain -- [file join $pgrdVar($dbname,log) *]]"


	# ripulisce <dbname>_Box
	set fnames  [file join $pgrdVar($dbname,inbox) *]
	set fnames [glob -nocomplain -- $fnames]
	set lfnames [split $fnames { }]
        puts $ldbfout "$now [clock clicks] deleting $lfnames from $pgrdVar($dbname,inbox) on $pgrdVar($dbname,lhost) ..."
	foreach lfname $lfnames {
		if {[catch {file delete $lfname} errmsg]} {
			puts $ldbfout "$now [clock clicks] deleting from $pgrdVar($dbname,inbox): $errmesg"
			}
		}
	puts $ldbfout "$now [clock clicks] $pgrdVar($dbname,inbox): [glob -nocomplain -- [file join $pgrdVar($dbname,inbox) *]]"


        set fnames  [file join $pgrdVar($dbname,outbox) *]
	set fnames [glob -nocomplain -- $fnames]
	set lfnames [split $fnames { }]
        puts $ldbfout "$now [clock clicks] deleting $lfnames from $pgrdVar($dbname,outbox) on $pgrdVar($dbname,lhost) ..."
	foreach lfname $lfnames {
        	if {[catch {file delete $lfname} errmsg]} {
                	puts $ldbfout "$now [clock clicks] deleting from $pgrdVar($dbname,outbox): $errmesg"
	                }
		}
	puts $ldbfout "$now [clock clicks] $pgrdVar($dbname,outbox): [glob -nocomplain -- [file join $pgrdVar($dbname,outbox) *]]"




        # cancella la tabella di log (pgr_qryengine_log)
	# (tranne che per pgr -rrs <dbname> !!!)
	puts $ldbfout  "$now [clock clicks] we are called by pgr ${pgr_arg} $dbname:"
	if {[string compare "-rrs" ${pgr_arg}]!=0} {
        	set query "delete from  pgr_qryengine_log"
        	puts $ldbfout  "$now [clock clicks] $query..."
        	set ris [query_exec $dbname $query]
        	puts $ldbfout  "$now [clock clicks] ...$ris"
		} else {
		puts $ldbfout  "$now [clock clicks] ...so we do not delete pgr_qryengine_log!"
		}


        # cancella la tabella di RST check  (pgr_rstcheck)     
        set query "delete from  pgr_rstcheck"
        puts $ldbfout  "$now [clock clicks] $query..."
        set ris [query_exec $dbname $query]
        puts $ldbfout  "$now [clock clicks] ...$ris"

        }
#---------------------------------------



#---------------------------------------
# lock (action=lock) or unlock (action=unlock) replicated tables
proc lock_replicated_tables { dbname action } {
        global pgrdVar
        set lfout $pgrdVar(pgrdlog)
	set ldbfout $pgrdVar($dbname,pgrdlog)
	set now "        "

	puts $ldbfout "$now [clock clicks]  ${action}ing $dbname..."

        # update locked attribute in pgr_tables
        # (this attribute is always checked by replica triggers)
        if {[string compare $action lock]==0} {
                set query "update pgr_tables set locked = true"
                } else {
                set query "update pgr_tables set locked = false"
                }
	if [catch {query_exec $dbname $query} err] {
		puts $ldbfout "$now [clock clicks] ${action}ing $dbname ERR - $err"
		return -code error "$err"
		} else { 
		puts $ldbfout "$now [clock clicks] ... Done"
		}
        }
#---------------------------------------




#---------------------------------------
#
proc reset_flows {dbname} {
        global pgrdVar
        set lfout $pgrdVar(pgrdlog)
	set ldbfout $pgrdVar($dbname,pgrdlog)
	set now "        "

set quotchar {"}

# define the local site_id 
set lsite $pgrdVar($dbname,lsite)

puts $ldbfout "$now [clock clicks] reset_flows in..."
foreach table $pgrdVar($dbname,$pgrdVar($dbname,lhost),tables) {

	# drop index ${table}_flow_idx
	set query "drop index ${quotchar}[myquote ${table}_flow_idx]${quotchar}"
	puts $ldbfout  "$now [clock clicks] $query..."
	if [catch {query_exec $dbname $query} err] {
		puts $ldbfout "$now [clock clicks] ...$err"
		} else {
		puts $ldbfout "$now [clock clicks] ... Done"
		}
	#set ris [query_exec $dbname $query]
        #puts $ldbfout  "$now [clock clicks] ...$ris"

        # delete remote operations and local LO operations
        set query "delete from ${quotchar}[myquote ${table}_flow]${quotchar} where pgr_sid_f(pgr_gfid)<>$lsite or pgr_optype=\'LO\'"
        puts $ldbfout  "$now [clock clicks] $query..."
	set ris [query_exec $dbname $query]
        puts $ldbfout  "$now [clock clicks] ...$ris"

        # reset flow_flag
        set query "update ${quotchar}[myquote ${table}_flow]${quotchar} set pgr_flow_flag=\'Y\'"
        puts $ldbfout  "$now [clock clicks] $query..."
	set ris [query_exec $dbname $query]
        puts $ldbfout  "$now [clock clicks] ...$ris"

	# vacuuming the table
	set query "VACUUM ${quotchar}[myquote ${table}_flow]${quotchar}"
        puts $ldbfout  "$now [clock clicks] $query..."
        set ris [query_exec $dbname $query]
        puts $ldbfout  "$now [clock clicks] ...$ris"

        }


puts $ldbfout "$now [clock clicks] reset_flows out"


}

#---------------------------------------



#---------------------------------------
#  RCP or RDO procedures
#---------------------------------------



#----------------------
# return daemon's state
#----------------------
proc WYS {dbname} {   ;# What's Your State ?
        global pgrdVar dp_rpcFile
	set lfout $pgrdVar(pgrdlog)
	if [info exists pgrdVar($dbname,state)] {
        	set tosend $pgrdVar($dbname,state)
		} else {
		if [catch {db_testConnect $dbname localhost $pgrdVar(pg_port)} err] {
			set tosend "Error connecting $dbname: $err"
			return -code error "$tosend"
			} else {
        		# check for lock file
        		set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]
        		if {[file exists $lockfname]} {
				#set pgrdVar($dbname,pgrdlock) [open $lockfname r+]
				#gets $pgrdVar($dbname,pgrdlock) line
				#set tosend $line
				#close $pgrdVar($dbname,pgrdlock)
				set tosend [exec cat $lockfname]
				} else {
				set pgrdVar($dbname,state) LISTEN
				set tosend LISTEN 
				}
			}
		}
	set now [clock format [clock seconds] -format %T]

        puts $lfout "$now WYS $dbname from $dp_rpcFile; returned $tosend"
        puts  "$now WYS $dbname from $dp_rpcFile; returned $tosend"
        puts $lfout "$now $dbname local state $tosend"
        puts "$now $dbname local state $tosend"
        return  $tosend
        }



#----------------------------
# ready to start with replica
#----------------------------
proc ALERT {action dbname pgr_arg} {   ;# Ready To Go ?
        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
	set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

	switch $action {

		UP	{
			# check for lock file
			#if {[file exists $lockfname]} {
			#	set lockfilevalue [exec cat $lockfname]
			#	set pgrdVar($dbname,state) $lockfilevalue
			#	} else {
			#	set lockfilevalue DoesNotExist
			#	}
	
		        if [info exists pgrdVar($dbname,state)] {
		                set retvalue $pgrdVar($dbname,state)
				if {[string compare $pgrdVar($dbname,state) LISTEN]==0} {
					set pgrdVar($dbname,state) READY
					}
		                } else {
				# is <dbname> a replicated database?
				if {![file isdirectory [file join $pgrdVar(pgrd_DATA) rbase $dbname]] } {
					set retvalue "Is $dbname a replicated database on site $pgrdVar($dbname,lsite) ?"
					} else {
			                if [catch {db_testConnect $dbname localhost $pgrdVar(pg_port)} err] {
                			        set retvalue "Error connecting $dbname: $err"
		        	                } else {
						# check for lock file
						if {[file exists $lockfname]} {
							set lockfilevalue [exec cat $lockfname]
							if {[string compare $lockfilevalue "-resolv"]==0 && [string compare $pgr_arg "-update"]==0} {
								set retvalue LISTEN
								set pgrdVar($dbname,state) READY
								} else {
								set pgrdVar($dbname,state) $lockfilevalue
								set retvalue $pgrdVar($dbname,state)
								}
							} else {
				                        set retvalue LISTEN
				                        set pgrdVar($dbname,state) READY
							}
						}
		                	}
				}	

			set now [clock format [clock seconds] -format %T]

		        puts $lfout "$now ALERT UP $dbname $pgr_arg from $dp_rpcFile; returned $retvalue"
		        puts  "$now ALERT UP $dbname $pgr_arg from $dp_rpcFile; returned $retvalue"

		        puts $lfout "$now $dbname local state $pgrdVar($dbname,state)"
		        puts  "$now $dbname local state $pgrdVar($dbname,state)"


			}


		DOWN	{

			# chiamato per riportare il demone allo stato di attesa
			# dopo che e' stato svegliato inutilmente
			# (quando e' arrivato ALERT UP ma altri hosts non erano disponibili per la replica)

		        # si disconnette da dbname e svuota pgrdVar(dbname,*)
		        catch {db_disconnect $dbname}

		        set retvalue LISTEN

		        # svuota il vettore pgrdVar degli elementi legati a dbname
		        foreach name [array names pgrdVar] {
		                # cerca indici del tipo (db,...)
		                if {[regexp {^([^,]+),.+} $name match db]} {
		                        # se db = dbname elimina l'elemento name del vettore pgrdVar
		                        if {[string compare $db $dbname]==0} {
		                                unset pgrdVar($name)
		                                }
		                        }
		                }

			}


		} ;# end of switch


        return  $retvalue

        }


#---------------------------
# RST check of dbname
#---------------------------
proc RSTchk { dbname hostmaster pgr_arg} {

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)

	set pgrdVar($dbname,state) "RSTchk_0"

        # <dbname> replica directories
        set pgrdVar($dbname,temp) [file join $pgrdVar(pgrd_DATA) rbase $dbname temp]
        set pgrdVar($dbname,log) [file join $pgrdVar(pgrd_DATA) rbase $dbname log]
        set pgrdVar($dbname,history) [file join $pgrdVar(pgrd_DATA) rbase $dbname history]
        set pgrdVar($dbname,inbox) [file join $pgrdVar(pgrd_BOX) $dbname in]
        set pgrdVar($dbname,outbox) [file join $pgrdVar(pgrd_BOX) $dbname out]

        # file di log del database corrente
        set logfname [file join $pgrdVar($dbname,log) ${dbname}.log]
	catch {file rename -force  $logfname [file join $pgrdVar($dbname,log) ${dbname}.log.pre]}
        set pgrdVar($dbname,pgrdlog) [open $logfname w+]
        fconfigure $pgrdVar($dbname,pgrdlog) -buffering none
	set ldbfout $pgrdVar($dbname,pgrdlog)

	# Large Object log file
	set logfname [file join $pgrdVar($dbname,log) LOprocs.log]
	catch {file rename -force  $logfname [file join $pgrdVar($dbname,log) LOprocs.log.pre]}
	set pgrdVar($dbname,lofout) [open $logfname w+]
	set lofout $pgrdVar($dbname,lofout)
	fconfigure $lofout -buffering none

        set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] RSTchk $dbname ${pgr_arg} from $dp_rpcFile"
        puts $lfout "$now RSTchk $dbname ${pgr_arg} from $dp_rpcFile"
        puts  "$now RSTchk $dbname ${pgr_arg} from $dp_rpcFile"
        set pgrdVar($dbname,replicamaster) $hostmaster


        # set pgrdVar($dbname,lhost), pgrdVar($dbname,rhosts) and pgrdVar($dbname,$host,tables)
        # calling distrib procedure;
        # tables structure holds informations about table
        # distribution among hosts for the specified database
        if [catch {distrib $dbname} errmsg] {
                set now [clock format [clock seconds] -format %T]
                set pgrdVar($dbname,state) "ERR/RSTchk/distrib/$errmsg"
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/RSTchk/distrib/$errmsg"
                }


        # delete previous replica session files                        
        if [catch {clear_old_files $dbname ${pgr_arg}} errmsg] {
		set pgrdVar($dbname,state) "ERR/RSTchk_0/clear_old_files/$errmsg"
		set now [clock format [clock seconds] -format %T]
		puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
		puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
		puts  "$now $dbname local state $pgrdVar($dbname,state) "
		return -code error "ERR/RSTchk_0/clear_old_files/$errmsg"
		}




	# crea file rst
	set RSTfile [file join $pgrdVar($dbname,temp) rst]
	exec echo "#pgr_lsite" > $RSTfile
	query_exec $dbname "copy pgr_lsite to \'/tmp/pgrtemp\' using delimiters \'|\'";
	exec cat /tmp/pgrtemp >> $RSTfile
	exec echo  "#pgr_hosts" >> $RSTfile
	query_exec $dbname "select * into  pgrhosts from pgr_hosts order by site"
	query_exec $dbname "copy pgrhosts to \'/tmp/pgrtemp\' using delimiters \'|\'";
	exec cat /tmp/pgrtemp >> $RSTfile
	exec echo  "#pgr_distrib" >> $RSTfile
	query_exec $dbname "select * into  pgrdistrib from pgr_distrib order by site, tablename"
	query_exec $dbname "copy pgrdistrib to \'/tmp/pgrtemp\' using delimiters \'|\'";
	exec cat /tmp/pgrtemp >> $RSTfile


	query_exec $dbname "drop table pgrhosts"
	query_exec $dbname "drop table pgrdistrib"

	# pone il contenuto del file nella stringa da ritornare al client pgr
	# formato: #tab1%tuples_tab1#tab2%tuples_tab2...
	# tuples: %tup1_field1|...|tup1_fieldn%tup2_field1|...
	set rsth [open $RSTfile r+]

	set retvalue ""

	while {![eof $rsth]} {
	        gets $rsth line
	        #puts $line
	        if {[ string compare [string index $line 0] #]==0} {
	                append retvalue "$line"
	                } else {
	                append retvalue "%$line"
	                }
	        }

	close $rsth
	# last line was an empty string so 
	set retvalue [string trimright $retvalue {%} ]



	set pgrdVar($dbname,state) "RSTchk_1"

        return  $retvalue

        }



#---------------------------
# start synchronization of db
#---------------------------
proc SYNC1 { dbname hostmaster} {
# flushout all local flows and propagate to resolv hosts

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)


	set ldbfout $pgrdVar($dbname,pgrdlog)

	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] SYNC1 $dbname from $dp_rpcFile"
        puts $lfout "$now SYNC1 $dbname from $dp_rpcFile"
        puts  "$now SYNC1 $dbname from $dp_rpcFile"
        set pgrdVar($dbname,replicamaster) $hostmaster


        # file di lock del database corrente
	# check for lock file (if exists, a previous replica session was not regularly ended)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]
	if {![file exists $lockfname]} {
	        #set pgrdVar($dbname,pgrdlock) [open $lockfname w+]
	        #fconfigure $pgrdVar($dbname,pgrdlock) -buffering none
		} else {
		#set pgrdVar($dbname,pgrdlock) [open $lockfname r+]
		#gets $pgrdVar($dbname,pgrdlock) line
		set line [exec cat $lockfname]
		puts $ldbfout "$now [clock clicks] lock file $lockfname: $line"
		puts $ldbfout "$now [clock clicks] replica not possible"
		puts $lfout "$now [clock clicks] lock file $lockfname: $line"
		puts $lfout "$now [clock clicks] replica not possible"
		puts  "$now lock file $lockfname: $line"
		puts  "$now replica not possible"
		return -code error "ERR/FOUT2R_0/lock_check/lock file($lockfname): $line"
		}
		

        # update/set replica session ID pgr_sessionid in pgr_lsite table
        set query "select * from pgr_lsite"
        set qry_handle [query_exec $dbname $query -return_handle]
        catch {unset risp}
        pg_result $qry_handle -assign risp
        if {[info exists risp(0,pgr_sessionid)]} {
                set sessionid $risp(0,pgr_sessionid)
                incr sessionid
                set query "update pgr_lsite set pgr_sessionid=$sessionid"
                puts $ldbfout  "$now [clock clicks] $query..."
                set ris [query_exec $dbname $query]
                puts $ldbfout  "$now [clock clicks] ...$ris"
                } else {
                # 4 previous pgr_lsite compatibility
                set sessionid 0
                }
        pg_result $qry_handle -clear
        catch {unset risp}
	set pgrdVar($dbname,sessionid) $sessionid
	set now [clock format [clock second] -format %T]
	puts $ldbfout "$now [clock clicks] Starting synchronization session n. $sessionid for $dbname"
	puts $lfout "$now [clock clicks] Starting synchronization session n. $sessionid for $dbname"
	puts  "$now Starting synchronization session n. $sessionid for $dbname"


        # lock dbname replicated tables
        if [catch {lock_replicated_tables $dbname lock} errmsg] {
                set pgrdVar($dbname,state) "ERR/FOUT2R_0/lock_replicated_tables(lock)/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
		set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/FOUT2R_0/lock_replicated_tables(lock)/$errmsg"
                }


        # Vacuuming of replicated tables
	set now [clock format [clock seconds] -format %T]
	puts $ldbfout "$now [clock clicks] Vacuuming of replicated tables..."
	foreach table $pgrdVar($dbname,$pgrdVar($dbname,lhost),tables) {
	        set query "vacuum $table"
		set now [clock format [clock seconds] -format %T]
	        puts $ldbfout  "$now [clock clicks] $query..."
	        set ris [query_exec $dbname $query]
		set now [clock format [clock seconds] -format %T]
	        puts $ldbfout  "$now [clock clicks] ...$ris"
	}
	


        # flushout user flows to resolv
        set pgrdVar($dbname,state) "FOUT2R_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {flushout $dbname user_flows} errmsg] {
                set pgrdVar($dbname,state) "ERR/FOUT2R_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
		set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/FOUT2R_0/$errmsg"
                }

        set pgrdVar($dbname,state) "FOUT2R_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



        #propagate flows_files to resolver sites
        set pgrdVar($dbname,state) "PROPOUT2R_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {propagationOUT $dbname 2resolv_sites} errmsg] {
                set pgrdVar($dbname,state) "ERR/PROPOUT2R_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
		set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now local state $pgrdVar($dbname,state) "
                puts "$now local state $pgrdVar($dbname,state) "
                return -code error "ERR/PROPOUT2R_0/$errmsg"
                }

        set pgrdVar($dbname,state) "PROPOUT2R_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        return [list $pgrdVar($dbname,lhost) $pgrdVar($dbname,state)]
        }





#---------------------


proc SYNC2 { dbname } {
# imports flows 2 resolve, resolve and propagate them

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
	set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] SYNC2 $dbname from $dp_rpcFile "
        puts $lfout "$now SYNC2 $dbname from $dp_rpcFile"
        puts  "$now SYNC2 $dbname from $dp_rpcFile"



        # propagationIN 
	# in propagationOUT si crea un file.tgz, lo si passa a sendData 
	# e poi lo si rimuove;
	# attualmente i files vengono trasferiti in sendData con la rcp;
	# a destinazione arriva quindi un file.tgz che deve essere scompattato
	# e rimosso
	# questo e' il compito di propagationIN (IN perche' deve essere eseguito 
	# prima di Flushin)
        set pgrdVar($dbname,state) "PROPIN2R_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {propagationIN $dbname } errmsg] {
                set pgrdVar($dbname,state) "ERR/PROPIN2R_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now local state $pgrdVar($dbname,state) "
                puts "$now local state $pgrdVar($dbname,state) "
                return -code error "ERR/PROPIN2R_0/$errmsg"
                }

        set pgrdVar($dbname,state) "PROPIN2R_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



        # flushin flows to be resolved
        set pgrdVar($dbname,state) "FIN2R_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {flushin $dbname flows2resolv} errmsg] {
                set pgrdVar($dbname,state) "ERR/FIN2R_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
		set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/FIN2R_0/$errmsg"
                }
        set pgrdVar($dbname,state) "FIN2R_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        # resolver
        set pgrdVar($dbname,state) "RES_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {resolver $dbname} errmsg] {
                set pgrdVar($dbname,state) "ERR/RES_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
		set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/RES_0/$errmsg"
                }
        set pgrdVar($dbname,state) "RES_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts "$now $dbname local state $pgrdVar($dbname,state) "



        # flushout resolved_flows
        set pgrdVar($dbname,state) "FOUTR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {flushout $dbname resolved_flows} errmsg] {
                set pgrdVar($dbname,state) "ERR/FOUTR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/FOUTR_0/$errmsg"
                }

        set pgrdVar($dbname,state) "FOUTR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



        # propagate resolved flows_files to remote  sites
        set pgrdVar($dbname,state) "PROPOUTR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {propagationOUT $dbname resolved_flows} errmsg] {
                set pgrdVar($dbname,state) "ERR/PROPOUTR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now local state $pgrdVar($dbname,state) "
                puts "$now local state $pgrdVar($dbname,state) "
                return -code error "ERR/PROPOUTR_0/$errmsg"
                }

        set pgrdVar($dbname,state) "PROPOUTR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        return [list $pgrdVar($dbname,lhost) $pgrdVar($dbname,state)]

        }



#--------------------------------------

proc SYNC3 { dbname } {
# import resolved flows


        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
	set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] SYNC3 $dbname from $dp_rpcFile"
        puts $lfout "$now SYNC3 $dbname from $dp_rpcFile"
        puts  "$now SYNC3 $dbname from $dp_rpcFile"



        # propagationIN
        # in propagationOUT si crea un file.tgz, lo si passa a sendData
        # e poi lo si rimuove;
        # attualmente i files vengono trasferiti in sendData con la rcp;
        # a destinazione arriva quindi un file.tgz che deve essere scompattato
        # e rimosso
        # questo e' il compito di propagationIN (IN perche' deve essere eseguito
        # prima di Flushin)
        set pgrdVar($dbname,state) "PROPINR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {propagationIN $dbname } errmsg] {
                set pgrdVar($dbname,state) "ERR/PROPINR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now local state $pgrdVar($dbname,state) "
                puts "$now local state $pgrdVar($dbname,state) "
                return -code error "ERR/PROPINR_0/$errmsg"
                }
        set pgrdVar($dbname,state) "PROPINR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



        # flushin resolved flows
        set pgrdVar($dbname,state) "FINR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {flushin $dbname resolved_flows} errmsg] {
                set pgrdVar($dbname,state) "ERR/FINR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/FINR_0/$errmsg"
                }
        set pgrdVar($dbname,state) "FINR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



        #  Large Object Exportation
        set pgrdVar($dbname,state) "LOexp_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        if [catch {LO_export $dbname} errmsg] {
                set pgrdVar($dbname,state) "ERR/LOexp_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/LOexp_0/$errmsg"
                }

        set pgrdVar($dbname,state) "LOexp_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



        return [list $pgrdVar($dbname,lhost) $pgrdVar($dbname,state)]

	}



#--------------------------------------

proc SYNC35 { dbname } {
# update tables and propagate query engine errors to mastersite


        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
	set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

	set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] SYNC35 $dbname from $dp_rpcFile"
        puts $lfout "$now SYNC35 $dbname from $dp_rpcFile"
        puts  "$now SYNC35 $dbname from $dp_rpcFile"



        #  Large Object Import
        set pgrdVar($dbname,state) "LOimp_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        if [catch {LO_import $dbname} errmsg] {
                set pgrdVar($dbname,state) "ERR/LOimp_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/LOimp_0/$errmsg"
                } 

        set pgrdVar($dbname,state) "LOimp_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



	# disable RI for replicated tables
	puts $ldbfout "$now [clock clicks] disabling RI for replicated tables..."
	pgrRI $dbname disable
	puts $ldbfout "$now [clock clicks] Done"

	# update tables locally generating remote operations
        set pgrdVar($dbname,state) "UP_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "

        if [catch {update_tables_fwd $dbname} errmsg] {
                set pgrdVar($dbname,state) "ERR/UP_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/UP_0/$errmsg"
                }

        set pgrdVar($dbname,state) "UP_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "




        #  Large Object Table Update
        set pgrdVar($dbname,state) "LOupd_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        if [catch {LO_update $dbname} errmsg] {
                set pgrdVar($dbname,state) "ERR/LOupd_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/LOupd0/$errmsg"
                }

        set pgrdVar($dbname,state) "LOupd_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "




        # flushout qryengine errors
        set pgrdVar($dbname,state) "FOUTERR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {flushout $dbname qryengine_errors} errmsg] {
                set pgrdVar($dbname,state) "ERR/FOUTERR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/FOUTERR_0/$errmsg"
                }

        set pgrdVar($dbname,state) "FOUTERR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "




        # propagate qryengine errors to mastersite
        set pgrdVar($dbname,state) "PROPOUTERR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {propagationOUT $dbname qryengine_errors} errmsg] {
                set pgrdVar($dbname,state) "ERR/PROPOUTERR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now local state $pgrdVar($dbname,state) "
                puts "$now local state $pgrdVar($dbname,state) "
                return -code error "ERR/PROPOUTERR_0/$errmsg"
                }
        set pgrdVar($dbname,state) "PROPOUTERR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        return [list $pgrdVar($dbname,lhost) $pgrdVar($dbname,state)]

        }



#-----------------------------------------

proc SYNC4 { dbname } {
# query engine errors check
# executed by dpRPC from pgr on replica_master site

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
        set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] SYNC4 $dbname from $dp_rpcFile"
        puts $lfout "$now SYNC4 $dbname from $dp_rpcFile"
        puts  "$now SYNC4 $dbname from $dp_rpcFile"


        # propagationIN
        # in propagationOUT si crea un file.tgz, lo si passa a sendData
        # e poi lo si rimuove;
        # attualmente i files vengono trasferiti in sendData con la rcp;
        # a destinazione arriva quindi un file.tgz che deve essere scompattato
        # e rimosso
        # questo e' il compito di propagationIN (IN perche' deve essere eseguito
        # prima di Flushin)
        set pgrdVar($dbname,state) "PROPINERR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {propagationIN $dbname } errmsg] {
                set pgrdVar($dbname,state) "ERR/PROPINERR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now local state $pgrdVar($dbname,state) "
                puts "$now local state $pgrdVar($dbname,state) "
                return "ERR/PROPINERR_0/$errmsg"
                }
        set pgrdVar($dbname,state) "PROPINERR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



        # flushin remote qryengine errors in local pgr_qryengine_log
        set pgrdVar($dbname,state) "FINERR_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "
        if [catch {flushin $dbname qryengine_errors} errmsg] {
                set pgrdVar($dbname,state) "ERR/FINERR_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return  "ERR/FINERR_0/$errmsg"
                }
        set pgrdVar($dbname,state) "FINERR_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "



	# check 4 query_engine errors in replica group
	# controlla che in pgr_qryengine_log non ci siano errori
	# (in tale tabella confluiscono infatti i log locali e gli errori remoti!)

	set now [clock format [clock seconds] -format %T]
	puts $ldbfout "$now [clock clicks] check 4 query_engine errors in replica group..."
	set errquery "select count(*) as errors from pgr_qryengine_log where qry_result !=\'\'"
	set qry_handle [query_exec $dbname $errquery -return_handle]
	pg_result $qry_handle -assign risp
	set errors $risp(0,errors)
	pg_result $qry_handle -clear

	if { $errors > 0 } {
		set retvalue "ERR/$errors qryengine errors present!"
		} else {
		set retvalue OK
		}

	set now [clock format [clock seconds] -format %T]
	puts $ldbfout "$now [clock clicks] $retvalue"

	return $retvalue

	}




#------------------------------------------

proc SYNC_END { dbname } {
# LO importing
# reset pgr_monitor, save flows tables in files and clear them, vacuum db
        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
        set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

        set now [clock format [clock seconds] -format %T]
        puts $lfout "$now SYNC_END $dbname from $dp_rpcFile"
        puts  "$now SYNC_END $dbname from $dp_rpcFile"


        set pgrdVar($dbname,state) "SYNC_END_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "


        # reset of pgr_monitor, history files updating and vacuum
        if [catch {sync_ok $dbname} errmsg] {
                set pgrdVar($dbname,state) "ERR/sync_ok/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/sync_ok/$errmsg"
                }


        set pgrdVar($dbname,state) "SYNC_END_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
        puts  "$now $dbname local state $pgrdVar($dbname,state) "

        return [list $pgrdVar($dbname,lhost) $pgrdVar($dbname,state)]

        }




#-------------------------------------------------

proc RCLOSE { dbname } {
# unlock replicated tables and disconnect from postgres backend

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
        set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] RCLOSE $dbname from $dp_rpcFile"
        puts $lfout "$now RCLOSE $dbname from $dp_rpcFile"
        puts  "$now RCLOSE $dbname from $dp_rpcFile"


        set retvalue LISTEN


        # reenable RI for replicated tables
        puts $ldbfout "$now [clock clicks] reenabling RI for replicated tables..."
        pgrRI $dbname enable
        puts $ldbfout "$now [clock clicks] Done"


	# vacuuming database
	# LO vacuming in pg_largeobject
	if [catch {LO_vacuum $dbname} err] {
        	set now [clock format [clock second] -format %T]
	        puts  "$now [clock clicks] WARNING: LO_vacuum $dbname ERR - $err"
	        puts $ldbfout "$now [clock clicks] WARNING: LO_vacuum $dbname ERR - $err"
        	}
	set query "vacuum"
	puts $ldbfout "$now [clock clicks] Vacuuming $dbname..."
	set ris [query_exec $dbname $query]
	puts $ldbfout "$now [clock clicks] $ris"


        # unlock replicated tables
	puts $ldbfout "$now [clock clicks] unlocking replicated tables..."
        if {[catch {lock_replicated_tables $dbname unlock} errmsg]} {
                puts $ldbfout "         [clock clicks] $errmsg"
		puts $ldbfout "         [clock clicks] Try again...
		if {[catch {lock_replicated_tables $dbname unlock} errmsg]} {
			puts $ldbfout "         [clock clicks] $errmsg"
			set retvalue $errmsg
			} else {
			puts $ldbfout "         [clock clicks] OK"
			}
		}


        # disconnecting from dbname and unsetting pgrdVar(dbname,*)
	puts $ldbfout "$now [clock clicks] db_disconnect $dbname..."
        if {[catch {db_disconnect $dbname} errmsg]} {
		puts $ldbfout "         [clock clicks] $errmsg"
		lappend retvalue "///$errmsg"
		} else {
		puts $ldbfout "         [clock clicks] OK"
		}

        set now [clock format [clock second] -format %T]

        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now [clock clicks] local state $pgrdVar($dbname,state) "


	# remove lock file
	set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]
	puts $ldbfout "$now [clock clicks] removing replica lock file $lockfname"
	if {[catch {file delete $lockfname} errmsg]} {
		puts $ldbfout "$now [clock clicks] $errmsg"
		lappend retvalue "///$errmsg"
		}


        # unsetting pgrdVar(dbname,*)
	puts $ldbfout "          unsetting pgrdVar related to $dbname database..."
        foreach name [array names pgrdVar] {
                # cerca indici del tipo (dbname,...)
                if {[regexp {^([^,]+),.+} $name match db]} {
                        # se db = dbname elimina l'elemento name del vettore pgrdVar
                        if {[string compare $db $dbname]==0} {
				puts $ldbfout "          pgrdVar($name):   $pgrdVar($name) "
                                unset pgrdVar($name)
                                }
                        }
                }
	puts $ldbfout "          Done"


	puts $ldbfout "$now [clock clicks] connection closed"

        #close replica session log file
	puts $ldbfout "$now [clock clicks] close $ldbfout"
        if {[catch {close $ldbfout} errmsg]} {
                puts $ldbfout "        [clock clicks] $errmsg"
		lappend retvalue "///$errmsg"
                }

        puts $lfout "$now [clock clicks] connection closed"

        return $retvalue

	}



#--------------------------------------------

proc STANDBY { dbname {pgr_arg {}}} {

# con STANDBY si chiude la connessione senza passare da SYNC_END
# perche' il DBA deve prima risolvere i problemi segnalati in pgr_qryengine_log;
# rispetto a RCLOSE lascia bloccate le tabelle replicate in modo
# che gli utenti non possano accedervi in scrittura;
# lascia inoltre il file di lock cosi' non sara' possibile avviare una 
# nuova sessione di replica senza chiudere quella attuale

# dopo aver risolto manualmente gli errori puo' lanciare "pgr <dbname> crs | rrs"
# 	(crs = close/commit replica session) 
#	(rrs = reset/rollback replica session)
# solo allora sara' eseguito SYNC_END (crs), oppure 
# si ritornera' alle condizioni antecedenti alla replica (rrs)

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
        set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]


        set now [clock format [clock seconds] -format %T]
        puts $lfout "$now STANDBY $dbname from $dp_rpcFile"
        puts  "$now STANDBY $dbname from $dp_rpcFile"


	# vacuuming  database
	#set now [clock format [clock seconds] -format %T]
	#puts $ldbfout "$now [clock clicks] vacuum $dbname..."
	#set query "vacuum"
	#set ris [query_exec $dbname $query ]
	#set now [clock format [clock seconds] -format %T]
	#puts $ldbfout "$now [clock clicks] ...$ris"


	#set retvalue "STANDBY" 
	set retvalue $pgrdVar($dbname,state)

	# disconnecting from dbname and unsetting pgrdVar(dbname,*)
        puts $ldbfout "$now [clock clicks] db_disconnect $dbname..."
        if {[catch {db_disconnect $dbname} errmsg]} {
                puts $ldbfout "         [clock clicks] $errmsg"
                lappend retvalue "///$errmsg"
                } else {
                puts $ldbfout "         [clock clicks] OK"
                }

        set now [clock format [clock second] -format %T]

        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
        puts $lfout "$now [clock clicks] local state $pgrdVar($dbname,state) "

	# write on lock file
	if {[string length $pgr_arg]!=0} {
		eval exec echo "$pgr_arg" > $lockfname
		puts $ldbfout "$now [clock clicks] lock file updated ($pgr_arg) for next replica session"
		}


        # send e-mail to replicator
	puts $ldbfout "$now [clock clicks] send e-mail to replicator"
	set domain $pgrdVar($dbname,lsite,domain)
        set S "pgReplicator Replica Session Error Report"
	set msg [format "[clock format [clock second]] \n\nhost:     $pgrdVar($dbname,lhost)\ndatabase: $dbname\n\npgReplicator ended in STANDBY the last replica session. \nPlease check related log files!\n" ]
        set cmd "echo \"$msg\" | mail replicator@${domain} -s \"$S\""
        #puts $ldbfout "$now [clock clicks] $cmd..."
        if {[catch {eval exec $cmd} errmsg]} {
                puts $ldbfout "$now [clock clicks] $errmsg"
                } else {
                puts $ldbfout "$now [clock clicks] OK"
                }


	# unsetting pgrdVar(dbname,*)
        foreach name [array names pgrdVar] {
                # cerca indici del tipo (db,...)
                if {[regexp {^([^,]+),.+} $name match db]} {
                        # se db = dbname elimina l'elemento name del vettore pgrdVar
                        if {[string compare $db $dbname]==0} {
				puts $ldbfout "         unset pgrdVar($name):   $pgrdVar($name) "
                                unset pgrdVar($name)
                                }
                        }
                }



        puts $ldbfout "$now [clock clicks] connection closed"

        #close replica session log file
        puts $ldbfout "$now [clock clicks] close $ldbfout"
        if {[catch {close $ldbfout} errmsg]} {
                puts $ldbfout "        [clock clicks] $errmsg"
                lappend retvalue "///$errmsg"
                }

        puts $lfout "$now [clock clicks] connection closed"




	
	return $retvalue

	}




#-------------------------------------------------

proc ROLLBACK { dbname } {

# replica session rollback:
# local database returns to the pre-replica state,
# but if tables have already been modified, relica goes into a STANDBY state,
# so DBA can manually check for errors.
#

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
        set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]

        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] ROLLBACK from  $dp_rpcFile"
        puts $lfout "$now ROLLBACK $dbname from  $dp_rpcFile"
        puts "$now ROLLBACK $dbname from  $dp_rpcFile"

        # local replica state: in case of error it will be ERR/state/errmsg
        if {[string first ERR $pgrdVar($dbname,state)]==0} {
                regexp {ERR/([^/]+)/.*} $pgrdVar($dbname,state) match rep_state
                } else {
                set rep_state $pgrdVar($dbname,state)
                }

        puts $ldbfout "$now [clock clicks] replica_state: \'$rep_state\'"

        switch  $rep_state {


		LISTEN
			-
                READY	
                        -
		RSTchk_0
			-
                FOUT2R_0
                        -
                FOUT2R_1
                        -
                PROPOUT2R_0 
                        -
                PROPOUT2R_1  {
			# we can directly close replica session without any rollback operation

                        # send e-mail to replicator
                        puts $ldbfout "$now [clock clicks] send e-mail to replicator"
                        set domain $pgrdVar($dbname,lsite,domain)
                        set S "pgReplicator Replica Session Error Report"
                        set msg [format "[clock format [clock second]] \n\nhost:     $pgrdVar($dbname,lhost)\ndatabase: $dbname\n\npgReplicator ROLLED BACK the last replica session. \nPlease check related log files!\n" ]
                        set cmd "echo \"$msg\" | mail replicator@${domain} -s \"$S\""
                        #puts $ldbfout "$now [clock clicks] $cmd..."
                        if {[catch {eval exec $cmd} errmsg]} {
                                puts $ldbfout "$now [clock clicks] $errmsg"
                                } else {
                                puts $ldbfout "$now [clock clicks] OK"
                                }

			set retvalue [RCLOSE $dbname]
			return $retvalue
                        }


                PROPIN2R_0
                        -
                PROPIN2R_1
                        -
                FIN2R_0
                        -
                FIN2R_1
                        -
                RES_0
			-
                RES_1
                        -
                PROPOUTR_0
                        -
                PROPOUTR_1
                        -
		FINR_0
			-
		FINR_1	
			-
                LOexp_0
			-
		LOexp_1	{
			# no table update till now, but auxiliary tables have been modified
			# so we rollback only auxiliary tables.

                        # send e-mail to replicator
                        puts $ldbfout "$now [clock clicks] send e-mail to replicator"
                        set domain $pgrdVar($dbname,lsite,domain)
                        set S "pgReplicator Replica Session Error Report"
                        set msg [format "[clock format [clock second]] \n\nhost:     $pgrdVar($dbname,lhost)\ndatabase: $dbname\n\npgReplicator ROLLED BACK the last replica session. \nPlease check related log files!\n" ]
                        set cmd "echo \"$msg\" | mail replicator@${domain} -s \"$S\""
                        #puts $ldbfout "$now [clock clicks] $cmd..."
                        if {[catch {eval exec $cmd} errmsg]} {
                                puts $ldbfout "$now [clock clicks] $errmsg"
                                } else {
                                puts $ldbfout "$now [clock clicks] OK"
                                }


			# we try again in case of error, then replica goes in STANDBY

                        #reset_flows $dbname
                        if {[catch {reset_flows $dbname} errmsg]} {
                                set pgrdVar($dbname,state) "ERR/ROLLBACK/reset_flows/$errmsg"
                                set now [clock format [clock seconds] -format %T]
                                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) ... again ..."
                                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) ... again ..."
                                puts  "$now $dbname local state $pgrdVar($dbname,state) ... again ..."

	                        if [catch {reset_flows $dbname} errmsg] {
        	                        set pgrdVar($dbname,state) "ERR/ROLLBACK/reset_flows(2)/$errmsg"
                	                set now [clock format [clock seconds] -format %T]
                        	        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                                	puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
	                                puts  "$now $dbname local state $pgrdVar($dbname,state) "
		
					set retvalue [STANDBY $dbname]
					return $retvalue

                	                } else {

					set retvalue [RCLOSE $dbname]
					return $retvalue
					}

				} else {

				set retvalue [RCLOSE $dbname]
				return $retvalue

				}

                        }

                LOimp_0
                        -
                LOimp_1 {
                        # no table update till now, but some LO has been imported
                        # so we rollback auxiliary tables and delete imported LO from pg_largeobject

                        # we try again in case of error, then replica goes in STANDBY

                        #reset_flows $dbname
                        if {[catch {reset_flows $dbname} errmsg]} {
                                set pgrdVar($dbname,state) "ERR/ROLLBACK/reset_flows/$errmsg"
                                set now [clock format [clock seconds] -format %T]
                                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) ... again ..."
                                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) ... again ..."
                                puts  "$now $dbname local state $pgrdVar($dbname,state) ... again ..."

                                if [catch {reset_flows $dbname} errmsg] {
                                        set pgrdVar($dbname,state) "ERR/ROLLBACK/reset_flows(2)/$errmsg"
                                        set now [clock format [clock seconds] -format %T]
                                        puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                                        puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                                        puts  "$now $dbname local state $pgrdVar($dbname,state) "

                                        set retvalue [STANDBY $dbname]
                                        return $retvalue

                                        } 
				}

			# delete from pg_largeobject imported LO
			set query "delete from pg_largeobject where loid in (select lloid from pgr_lomap where rsiteid>0)"
			puts $ldbfout "$now [clock clicks] $query"
			set ris [query_exec $dbname $query]
			puts $ldbfout "$now [clock clicks] ...Done"

		        # send e-mail to replicator
		        puts $ldbfout "$now [clock clicks] send e-mail to replicator"
		        set domain $pgrdVar($dbname,lsite,domain)
		        set S "pgReplicator Replica Session Error Report"
		        set msg [format "[clock format [clock second]] \n\nhost:     $pgrdVar($dbname,lhost)\ndatabase: $dbname\n\npgReplicator ROLLED BACK the last replica session. \nPlease check related log files!\n" ]
		        set cmd "echo \"$msg\" | mail replicator@${domain} -s \"$S\""
		        #puts $ldbfout "$now [clock clicks] $cmd..."
		        if {[catch {eval exec $cmd} errmsg]} {
		                puts $ldbfout "$now [clock clicks] $errmsg"
		                } else {
		                puts $ldbfout "$now [clock clicks] OK"
		                }

			set retvalue [RCLOSE $dbname]
			return $retvalue

                        }


                UP_0    
			-
                UP_1    
                       -
		LOupd_0
			-
		LOupd_1
			- 
                FOUTERR_0
                        -
                FOUTERR_1
                        -
                PROPOUT2R_0
                        -
                PROPOUTERR_1  
			-
                PROPINERR_0
                        -
                PROPINERR_1
                        -
                FINERR_0
                        -
                FINERR_1
			-
		SYNC_END_0
			-
		SYNC_END_1 {
			# replica session goes in STANDBY state because
			# user's tables have already been modified by replicator.
			# This is NOT a rollback: 
			# you have to run pgr again with crs or rrs argument!

                        set retvalue [STANDBY $dbname]
                        return $retvalue
			}

		RRS_0	
			-

		RRS_1	{
			# errors occured during rollback: replica goes into a STANDBY state
                        set retvalue [STANDBY $dbname]
                        return $retvalue
			}


                default {
                        puts $lfout "$now [clock clicks] $dbname ERROR: replica state unknown!"
                        puts $ldbfout "$now [clock clicks] ERROR: replica state unknown!"
                        # va in STANDBY
                        set retvalue [STANDBY $dbname]
                        return $retvalue
                        }

                }

        }




#-------------------------------------------------
# Reset Replica Session
#-------------------------------------------------
# 
# rollback replica session called by pgr;

proc RRS { dbname } {

        global pgrdVar dp_rpcFile
        set lfout $pgrdVar(pgrdlog)
        set ldbfout $pgrdVar($dbname,pgrdlog)
        set lockfname [file join $pgrdVar(pgrd_DATA) rbase ${dbname}.lock]
	

	set pgrdVar($dbname,state) "RRS_0"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname

        set now [clock format [clock seconds] -format %T]
        puts $ldbfout "$now [clock clicks] RRS $dbname from $dp_rpcFile"
        puts $lfout "$now RRS $dbname from $dp_rpcFile"
        puts  "$now RRS $dbname from $dp_rpcFile"


	# rollback replicator's operations on user's tables
        if [catch {update_tables_rew $dbname} errmsg] {
                set pgrdVar($dbname,state) "ERR/RRS_0/$errmsg"
		eval exec echo "$pgrdVar($dbname,state)" > $lockfname
                set now [clock format [clock seconds] -format %T]
                puts $ldbfout "$now [clock clicks] local state $pgrdVar($dbname,state) "
                puts $lfout "$now $dbname local state $pgrdVar($dbname,state) "
                puts  "$now $dbname local state $pgrdVar($dbname,state) "
                return -code error "ERR/RRS_0/$errmsg"
                }

	set pgrdVar($dbname,state) "RRS_1"
	eval exec echo "$pgrdVar($dbname,state)" > $lockfname
	set now [clock format [clock seconds] -format %T]
	puts $ldbfout "$now [clock clicks] local state RRS_1"


        return [list $pgrdVar($dbname,lhost) $pgrdVar($dbname,state)]


	}

#///////////////////////////////////////////////
