#-----------------------------------------------
#               FLUSHIN
#-----------------------------------------------


# imports files like host_db_tab_flow into tab_flow
# che andranno in ingresso al conflict_detector


proc flushin {dbname what} {
global pgrdVar
set lfout $pgrdVar(pgrdlog)
set ldbfout $pgrdVar($dbname,pgrdlog)

set lhost $pgrdVar($dbname,lhost)


set now [clock format [clock seconds] -format %T]
puts $ldbfout   "$now [clock clicks] Flushin  $dbname $what on  $lhost" 


set now "        "


switch  $what {



	flows2resolv      {

		# per ciascuna tabella di flussi che il sito locale deve passare al resolver, 
		# importo i flussi remoti scaricati in pgrdVar($dbname,inbox) 

		puts $ldbfout "$now [clock clicks] tables2resolv on $lhost: $pgrdVar($dbname,$lhost,tables2resolv)"
		foreach table $pgrdVar($dbname,$lhost,tables2resolv) {

	        	foreach rhost $pgrdVar($dbname,rhosts) {

				#puts $ldbfout "$now [clock clicks] remote host: $rhost..."
		                set localflow ${table}_flow
	        	        set abs_remote_flow_file [file join $pgrdVar($dbname,inbox) ${rhost}_${dbname}_$localflow]

	        	        if {[file exists $abs_remote_flow_file]} {
        		                set query "copy [myquote $localflow] from \'[myquote $abs_remote_flow_file]\'"
	                	        puts $ldbfout "$now [clock clicks] $query..."

	                        	if {[catch {query_exec $dbname $query} ret]} {
        	        	                puts $ldbfout  "$now [clock clicks] ...$ret"
                		                return -code error "$ret"
        	                	        }

		                        puts $ldbfout  "$now [clock clicks] ...$ret"

        	        	        }

                		} ;# end of foreach rhost

		        } ;# end of foreach table


		}


        resolved_flows  {
                # per ciascuna tabella di flussi locale risolta su un altro sito,
                # importo i flussi remoti risolti scaricati in pgrdVar($dbname,inbox)

                foreach table $pgrdVar($dbname,$lhost,tables) {

                        foreach rhost $pgrdVar($dbname,rhosts) {

				if {[lsearch -exact $pgrdVar($dbname,$rhost,tables2resolv) $table]>=0} {

                                	set localflow ${table}_flow
					puts $ldbfout  "$now [clock clicks] importing $localflow resolved on host $rhost..."
                        	        set abs_remote_flow_file [file join $pgrdVar($dbname,inbox) res_${rhost}_${dbname}_$localflow]

                	                if {[file exists $abs_remote_flow_file]} {
						# marking flows to delete
						set query "update [myquote $localflow] set pgr_flow_flag=\'D\'"
                                                puts $ldbfout "$now [clock clicks] $query..."
                                                if {[catch {query_exec $dbname $query} ret]} {
                                                        puts $ldbfout  "$now [clock clicks] ...$ret"
                                                        return -code error "$ret"
                                                        }
                                                puts $ldbfout  "$now [clock clicks] ...$ret"

						
						# importing resolved flows
        	                                set query "copy [myquote $localflow] from \'[myquote $abs_remote_flow_file]\'"
	                                        puts $ldbfout "$now [clock clicks] $query..."
                                	        if {[catch {query_exec $dbname $query} ret]} {
                        	                        puts $ldbfout  "$now [clock clicks] ...$ret"
                	                                return -code error "$ret"
        	                                        }
	
        	                                puts $ldbfout  "$now [clock clicks] ...$ret"
	
						# deleting marked tuples
						set query "delete from [myquote $localflow] where pgr_flow_flag=\'D\'"
						puts $ldbfout "$now [clock clicks] $query..."
                                                if {[catch {query_exec $dbname $query} ret]} {
                                                        puts $ldbfout  "$now [clock clicks] ...$ret"
                                                        return -code error "$ret"
                                                        }
        	                                puts $ldbfout  "$now [clock clicks] ...$ret"

	                                        } else {
						# non dovrebbe verificarsi
						# $abs_remote_flow_file not found
						set warn "WARNING: $abs_remote_flow_file not found; it is assumed that no user operations where generated!"
						puts stderr $warn
						puts $ldbfout  "$now [clock clicks] ...$warn"
						#return -code error "$abs_remote_flow_file not found"
						}

					}

                                } ;# end of foreach rhost

                        } ;# end of foreach table


                }



        qryengine_errors {

		# solo sul replicamaster!!!
		foreach rhost $pgrdVar($dbname,rhosts) {

	                #set errtable pgr_qryengine_err
	                set errtable pgr_qryengine_log
        	        set errfile ${rhost}_${dbname}_errors

	                # copy errfile into errtable
        	        set absfname [file join $pgrdVar($dbname,inbox) $errfile]
                	set query "copy [myquote $errtable] from \'[myquote $absfname]\'"
	                puts $ldbfout  "$now [clock clicks] $query..."

        	        if {[catch {query_exec $dbname $query} ret]} {
                	        puts $ldbfout  "$now [clock clicks] ...$ret"
                        	return -code error "$ret"
	                        }

                	puts $ldbfout  "$now [clock clicks] ...$ret"
			}

                }


        default {

                }

        } ;# end of switch






set now [clock format [clock seconds] -format %T]


puts $ldbfout "$now [clock clicks] Flushin $what:   End of procedure"

}

# ---------- END OF FLUSHIN -----------



