#-----------------------------------------------
#               FLUSHOUT
#-----------------------------------------------
# Fa la scansione delle tabelle locali e di queste crea una copia
# su disco locale, in modo da poterli successivamente propagare

# VERSION:    1.09.1


# denominazione files:
# host:                 hostname
# tabella:              tablename
# tabella dei flussi:   tablename_flow
# file dei flussi:      hostname_dbname_tablename_flow (flussi non risolti)
#			res_hostname_dbname_tablename_flow (flussi risolti)
# directory:            $PGRBOX/<dbname>/out



proc flushout {dbname what} {

global pgrdVar
set lfout $pgrdVar(pgrdlog)
set lhost $pgrdVar($dbname,lhost)
set ldbfout $pgrdVar($dbname,pgrdlog)


set now [clock format [clock second] -format %T]
puts $ldbfout  [format "$now [clock clicks] Flushout\t$dbname\t$what" ]

set now "        "



switch  $what {

	user_flows	{
		# exporting local auxiliary tables 

		foreach table $pgrdVar($dbname,$lhost,tables) {
		        set flowtable ${table}_flow
		        set query "select count(*) as flot from [myquote $flowtable]"
			#puts $ldbfout  "$now [clock clicks] $query ..."
			set qry_handle [query_exec $dbname $query -return_handle] 
		        pg_result $qry_handle -assign risp
		        set acc $risp(0,flot)
		        pg_result $qry_handle -clear
		        puts $ldbfout "$now [clock clicks] $flowtable tuples: $acc"
		
		        if {$acc>0} {
		
		                set flowfile ${lhost}_${dbname}_$flowtable
		
		                # ...copy flow_table into flow_file
		                set fname [file join $pgrdVar($dbname,outbox) $flowfile]
		                set query "copy [myquote $flowtable] to \'[myquote $fname]\'"
		                puts $ldbfout  "$now [clock clicks] $query..."
		
				if {[catch {query_exec $dbname $query} ret]} {
					puts $ldbfout  "$now [clock clicks] ...$ret"
					return -code error "$ret"
					}
		
		                puts $ldbfout  "$now [clock clicks] ...$ret"
		
		                }
			}

	        }


	resolved_flows	{
		# exporting global auxiliary tables locally resolved
		# (a site can resolv conflicts on a table T only if T exists and
		# is a replicated table on that site!)

                foreach res_table $pgrdVar($dbname,$lhost,tables2resolv) {
                        set flowtable ${res_table}_flow
                        set query "select count(*) as flot from [myquote $flowtable]"
                        #puts $ldbfout  "$now [clock clicks] $query ..."
                        set qry_handle [query_exec $dbname $query -return_handle]
                        pg_result $qry_handle -assign risp
                        set acc $risp(0,flot)
                        pg_result $qry_handle -clear
                        puts $ldbfout "$now [clock clicks] $flowtable tuples: $acc"

                        if {$acc>0} {

                                set flowfile res_${lhost}_${dbname}_$flowtable

                                # ...copia la tabella_flow nel file dei flussi
                                set fname [file join $pgrdVar($dbname,outbox) $flowfile]
                                set query "copy [myquote $flowtable] to \'[myquote $fname]\'"
                                puts $ldbfout  "$now [clock clicks] $query..."

                                if {[catch {query_exec $dbname $query} ret]} {
                                        puts $ldbfout  "$now [clock clicks] ...$ret"
                                        return -code error "$ret"
                                        }

                                puts $ldbfout  "$now [clock clicks] ...$ret"

                                }
			}
		}


	qryengine_errors {

		set errtable pgr_qryengine_err
		set errfile ${lhost}_${dbname}_errors

		#create errtable from  pgr_qryengine_log
		set query "create table $errtable as select * from pgr_qryengine_log where qry_result !=\'\'"
		puts $ldbfout  "$now [clock clicks] $query..."
                if {[catch {query_exec $dbname $query} ret]} {
                        puts $ldbfout  "$now [clock clicks] ...$ret"
                        return -code error "$ret"
                        }
		puts $ldbfout  "$now [clock clicks] ...$ret"


		# copy errtable into errfile 
		set absfname [file join $pgrdVar($dbname,outbox) $errfile]
		set query "copy [myquote $errtable] to \'[myquote $absfname]\'"
		puts $ldbfout  "$now [clock clicks] $query..."

		if {[catch {query_exec $dbname $query} ret]} {
			puts $ldbfout  "$now [clock clicks] ...$ret"
			return -code error "$ret"
			}
		puts $ldbfout  "$now [clock clicks] ...$ret"


                # drop errtable 
                set query " drop table $errtable "
                puts $ldbfout  "$now [clock clicks] $query..."
                if {[catch {query_exec $dbname $query} ret]} {
                        puts $ldbfout  "$now [clock clicks] ...$ret"
                        return -code error "$ret"
                        }


		puts $ldbfout  "$now [clock clicks] ...$ret"

		}



	default {

		# non definito

		}


	} ;# end of switch




set now [clock format [clock second] -format %T]

puts $ldbfout "$now [clock clicks] Flushout $what:   End of procedure"

}

# ------------ END OF FLUSHOUT -----------------


