#-----------------------------------------------------------------
#       SALVA LE OPERAZIONI LOCALI RIGETTATE E STORICIZZA I FLUSSI
#-----------------------------------------------------------------


# Version 1.08.1


#///////////////////////////////////////////////


proc save_rejected_operations {dbname} {

# DA ELIMINARE O MODIFICARE PERCHE' query_engine NON E' LO STESSO DI PRIMA!!!
 
global pgrdVar
	set lfout $pgrdVar(pgrdlog)
	set lhost $pgrdVar($dbname,lhost)
        set ldbfout $pgrdVar($dbname,pgrdlog)
        set now "        "


	#set now [clock format [clock second]]
	#puts $ldbfout [format "$now [clock clicks] query_engine  $dbname"]


	# apre il file dbname_rej.sql

	set fwdfname [file join $pgrdVar($dbname,log) ${dbname}_rej.sql]
	set fwdf [open  $fwdfname w+]
	fconfigure $fwdf -buffering none
	set pgrdVar($dbname,qesql) $fwdf

	# scrive sul file dbname_rej.sql da query_engine
	foreach table $pgrdVar($dbname,$lhost,tables) {

        	# salvataggio operazioni locali rifiutate
	        puts $ldbfout "$now [clock clicks] saving local rejected operations on table $table: (query_engine $dbname $table local rejected forward $fwdfname)..."
        	query_engine $dbname $table local rejected forward $fwdfname
	        puts $lfout "$now [clock clicks] ...Done"

        	} ;# end of foreach table


	# chiude il file
	close $fwdf

	}





#///////////////////////////////////////////////

# ritorna a ciuscun utente le sue operazioni rigettate
proc email_rej_op { dbname } {

global pgrdVar
set lfout $pgrdVar(pgrdlog)
set ldbfout $pgrdVar($dbname,pgrdlog)
set now "        "

set msgfout [file join $pgrdVar($dbname,temp) mailoprej.tmp]
set msgfin [file join $pgrdVar(pgrd_proc) email.$pgrdVar(language)]


set mail_table_lst {}
puts $ldbfout "$now [clock clicks] mail_table_lst:"
pg_select $pgrdVar($dbname,lconn) "select tablename from pgr_tables where silent = \'f\'" table {
	lappend mail_table_lst $table(tablename)
	puts $ldbfout "$now $now $table(tablename)"
	} ;# end of pg_select


# definisco il sito locale 
set locale $pgrdVar($dbname,lsite)
set domain $pgrdVar($dbname,lsite,domain)

foreach mtable $mail_table_lst {

	# trovo la lista dei campi della tabella <mtable>
	set fields [list ] ;    # inizializza la lista: fields
	pg_select $pgrdVar($dbname,lconn) "select attname from pg_attribute where attnum>0 and attrelid=(select oid from pg_class where relname=\'[myquote $mtable]\')"  fieldname {
        	set fields [linsert [set fields] end $fieldname(attname)]; # aggiunge in coda alla lista il nuovo campo
	        }


	set flowtable ${mtable}_flow
	pg_select $pgrdVar($dbname,lconn) "select * from  [myquote $flowtable] where pgr_optype!=\'Uo\' and pgr_sid_f(pgr_gfid)=$locale and pgr_flow_flag!=\'Y\' order by pgr_gfid asc" trans {

		set username $trans(pgr_username)
		set tablename $mtable
		set timestamp $trans(pgr_when)
		set floid pgr_rid_f($trans(pgr_gfid))
		set fromsite pgr_sid_f($trans(pgr_gfid))
		switch $trans(pgr_optype) {
			I	{set op INSERT}
			Un	{set op UPDATE}
			D	{set op DELETE}
			}

		# crea messaggio
		set msghout [open $msgfout w]
		fconfigure $msghout -buffering none
		set msghin [open $msgfin r]

		while {![eof $msghin]} {
			set line [gets $msghin]
			set cmdout "puts $msghout \""
			append cmdout $line
			append cmdout \"
			eval $cmdout
			#puts $lfout "$cmdout"
			} 


		puts $msghout [format "|%-20s|C|%-40s|%-40s|" "Nome campo" "Valore Impostato" "Valore precedente"]
		puts $msghout "|--------------------|-|----------------------------------------|----------------------------------------|"
		# maschera record
		switch $trans(dir_trans) {

			I	{
				foreach field $fields {
					set cmdout "puts $msghout \""
					set newfvalue [myquote $trans($field)]
					if {[string compare $newfvalue NULL]==0} {set newfvalue ""}
					append cmdout [format "|%-20s| |%-40s|%-40s|"  $field $newfvalue ""]
					append cmdout \"
					eval $cmdout
			#puts $lfout "$cmdout"
					}
				}

			U	{
				foreach field $fields {
					set newrec($field) $trans($field)
					}
				pg_select $pgrdVar($dbname,lconn) "select * from  [myquote $flowtable] where pgr_gfid = pgr_gxid_f($locale, $floid) and pgr_optype!=\'Un\'" oldtrans {
					foreach field $fields {
						set oldrec($field) $oldtrans($field)
						}
					}
				foreach field $fields {
					set cmdout "puts $msghout \""
					set newfvalue [myquote $newrec($field)]
					set oldfvalue [myquote $oldrec($field)]
					if {[string compare $newfvalue NULL]==0} {set newfvalue ""}
					if {[string compare $oldfvalue NULL]==0} {set oldfvalue ""}
					if {[string compare $newfvalue $oldfvalue]==0} {set C " "} else {set C "*"}
					append cmdout [format "|%-20s|%s|%-40s|%-40s|" $field $C $newfvalue $oldfvalue ]
					append cmdout \"
					eval $cmdout
			#puts $lfout "$cmdout"
					}

				}

			D	{
				foreach field $fields {
					set cmdout "puts $msghout \""
					set oldfvalue [myquote $trans($field)]
					if {[string compare $oldfvalue NULL]==0} {set oldfvalue ""}
					append cmdout [format "|%-20s| |%-40s|%-40s|"  $field "" $oldfvalue ]
					append cmdout \"
					eval $cmdout
			#puts $lfout "$cmdout"
					}
				}

			} ;# end of switch
		
		close $msghout
		close $msghin




		# spedisci messaggio
		set S "pgReplicator Conflicts Resolution Error Report"
		set cmd "cat $msgfout | mail ${username}@${domain} -s \"$S\""
		puts $ldbfout "$now [clock clicks] $cmd..."
		if {[catch {eval exec $cmd} errmsg]} {
			puts $ldbfout "$now [clock clicks] $errmsg"
			} else {
			puts $ldbfout "$now [clock clicks] OK"
			} 


		} ;# end of pg_select

	} ;# end of foreach mtable

} ;# end of proc email_rej_op 





#///////////////////////////////////////////////

proc sync_ok {dbname} {
global pgrdVar
set lfout $pgrdVar(pgrdlog)
set lconn $pgrdVar($dbname,lconn)
set lhost $pgrdVar($dbname,lhost)
set ldbfout $pgrdVar($dbname,pgrdlog)

set quotchar {"}

set now [clock format [clock second] -format %T]
puts $ldbfout [format "\n$now [clock clicks] History for $dbname"]
set now "        "



# reset  pgr_monitor
set query "update  pgr_monitor set i_acc=0, u_acc=0, d_acc=0, when_occurred=\'now\'"
puts $ldbfout  "$now [clock clicks] $query..."
set ris [query_exec $dbname $query]
puts $lfout  "$now [clock clicks] ...$ris"



# save local rejected operations
puts $ldbfout  "$now [clock clicks] save_rejected_operations $dbname ..."
if {[catch {save_rejected_operations $dbname} errmsg]} {
	puts $ldbfout  "$now [clock clicks] ... ERROR: $errmsg"
	} else {
	puts $ldbfout  "$now [clock clicks] ... Done"
	}



# alert users whose oparations have been rejected by e-mail message
set now [clock format [clock second] -format %T]
puts $ldbfout  "$now [clock clicks] email_rej_op $dbname"
if {[catch {email_rej_op $dbname} errmsg]} {
	puts $ldbfout  "$now [clock clicks] ... ERROR: $errmsg"
	} else {
	puts $ldbfout  "$now [clock clicks] ... Done"
	} 


# select pgr_sessionid from pgr_lsite
set query "select * from pgr_lsite"
set qry_handle [query_exec $dbname $query -return_handle]
catch {unset risp}
pg_result $qry_handle -assign risp
if {[info exists risp(0,pgr_sessionid)]} {
        set sessionid $risp(0,pgr_sessionid)
        } else {
        # 4 previous pgr_lsite compatibility
        set sessionid 0
        }
pg_result $qry_handle -clear
catch {unset risp}



# save auxiliary tables havin history=true into a file before delete them;
# <table_flow_hst> tables are created if errors occurs when copying tables into files
pg_select $lconn "select tablename from pgr_tables where history ='t'" HST {

        set flowtable $HST(tablename)_flow
	# date format: yyyy-mm-dd
	set today [clock format [clock seconds] -format %Y-%m-%d]
        set flowfile ${today}-$flowtable


        # select table_flow into table_flow_tmp
        set tmpflowtable ${flowtable}_tmp
        set query "drop table ${quotchar}[myquote $tmpflowtable]${quotchar}"
        catch {query_exec $dbname $query}
        set query "select $sessionid, * into ${quotchar}[myquote $tmpflowtable]${quotchar} from ${quotchar}[myquote $flowtable]${quotchar}"
        puts $ldbfout  "$now [clock clicks] $query..."
        set ris [query_exec $dbname $query]
        puts $ldbfout  "$now [clock clicks] ...$ris"


        # ...copy tabella_flow into file PRGRDATA/<dbname>/history/temp1...
        set fname1 [file join $pgrdVar($dbname,history) temp1]
	set query "copy ${quotchar}[myquote $tmpflowtable]${quotchar} to \'[myquote $fname1]\'"
        puts $ldbfout  "$now [clock clicks] $query..."

        if {[catch {query_exec $dbname $query} ret]} {
                puts $ldbfout  "$now [clock clicks] ...$ret"
		# trasferisco i flussi in table_flow_hst (da trasferire  poi manualmente)
		set query "select * into [myquote $flowtable]_hst from [myquote $flowtable]"
		puts $ldbfout  "$now [clock clicks] $query..."
		set ris [query_exec $dbname $query]
		puts $ldbfout  "$now [clock clicks] ...$ris"
                } else {

                puts $ldbfout  "$now [clock clicks] ...$ret"

                # ...and append to auxiliary file 
                set histfile [file join $pgrdVar($dbname,history) ${flowfile}]
                #set fname2 [file join $pgrdVar($dbname,history) temp2]

                if {[file size $fname1]>0} {

			eval exec cat $fname1 >> $histfile

                        }
                }

        set query "drop table ${quotchar}[myquote $tmpflowtable]${quotchar}"
        catch {query_exec $dbname $query}

        } ;# end of pg_select

# delete dummy file fname1
catch {file delete $fname1}



# delete auxiliary tables

foreach reptable $pgrdVar($dbname,$lhost,tables) {
        set flowtable ${reptable}_flow

        # drop index ${flowtable}_idx
        set query "drop index ${quotchar}[myquote ${flowtable}_idx]${quotchar}"
        puts $ldbfout  "$now [clock clicks] $query..."
        if [catch {query_exec $dbname $query} err] {
                puts $ldbfout "$now [clock clicks] ...$err"
                } else {
                puts $ldbfout "$now [clock clicks] ... Done"
                }
        #set ris [query_exec $dbname $query]
        #puts $ldbfout  "$now [clock clicks] ...$ris"

	# delete data from auxiliary tables
        set query "delete from ${quotchar}[myquote $flowtable]${quotchar}"
        puts $ldbfout  "$now [clock clicks] $query..."
	set ris [query_exec $dbname $query]
        puts $ldbfout  "$now [clock clicks] ...$ris"

        } ;# end of foreach



# save pgr_lomap into a file in history directory

# select pgr_lomap into pgr_lomap_tmp
set query "drop table pgr_lomap_tmp"
catch {query_exec $dbname $query}
set query "select $sessionid, * into pgr_lomap_tmp from pgr_lomap"
puts $ldbfout  "$now [clock clicks] $query..."
set ris [query_exec $dbname $query]
puts $ldbfout  "$now [clock clicks] ...$ris"

# ...copy pgr_lomap_tmp into file PRGRDATA/<dbname>/history/temp1...
set fname1 [file join $pgrdVar($dbname,history) temp1]
set query "copy pgr_lomap_tmp to \'[myquote $fname1]\'"
puts $ldbfout  "$now [clock clicks] $query..."

if {[catch {query_exec $dbname $query} ret]} {
        puts $ldbfout  "$now [clock clicks] ...$ret"
        puts $ldbfout  "$now [clock clicks] pgReplicator will not drop pgr_lomap_tmp table permitting replicator to manually add it to pgr_lomap.hst file in $pgrdVar($dbname,history) directory"

        } else {

        puts $ldbfout  "$now [clock clicks] ...$ret"

        # ...and append to auxiliary file
        set histfile [file join $pgrdVar($dbname,history) pgr_lomap.hst]
        if {[file size $fname1]>0} {
                eval exec cat $fname1 >> $histfile
                }
        set query "drop table pgr_lomap_tmp"
        catch {query_exec $dbname $query}
	catch {file delete $fname1}
        }


set now [clock format [clock second] -format %T]
puts $ldbfout "$now [clock clicks] history out"


}

