proc db_testConnect {dbname host port} {
global pgrdVar
	if {[info exists pgrdVar($dbname,lconn)]} {
	return $pgrdVar($dbname,lconn)
		} else {
		set count 1
		catch {set count $pgrdVar(dbNconn)}
		while {$count > 0} {
			if {[catch {pg_connect $dbname -port $port -host $host} lconn]} {
				puts "[clock format [clock second] -format %T] trying to connect to database $dbname on $host (port $port)"
				incr count -1
				set dbwait 3000
				catch {set dbwait $pgrdVar(dbWait)}
				after $dbwait { set w 1 }
				vwait w
				} else {
				set pgrdVar($dbname,lconn) $lconn
				return $pgrdVar($dbname,lconn)
				}
			}
		return -code error $lconn
		}
	}



proc db_connect {dbname host port} {
global pgrdVar
	#set lfout $pgrdVar(pgrdlog)
        if [catch {pg_connect $dbname -port $port -host $host} lconn] {
                return -code error $lconn
                } else {
		set pgrdVar($dbname,lconn) $lconn
		return 
		}
	}



proc db_disconnect {dbname} {
global pgrdVar
	#set lfout $pgrdVar(pgrdlog)
	set dbhandle $pgrdVar($dbname,lconn)
	if [catch {pg_disconnect $dbhandle} errmsg] {
		return -code error $errmsg
		}
	catch {unset pgrdVar($dbname,lconn)}
	}



proc query_exec {dbname query {risp {}}} {

# risp fa ritornare l'handle del risultato della query
# in modo da poter accedere ai risultati richiesti
# (in tal caso non si ripulisce con pg_result -clear)
# risp e' il terzo argomento e puo' essere una stringa qualsiasi (es. -risp)
# Es di utilizzo con risp: 
#	set query "select count(*) as tupnum from tablename"
#	set qry_handle [query_exec dbname $query -return_handle]
#	pg_result $qry_handle -assign risp
#	set acc $risp(0,tupnum)
#	pg_result $qry_handle -clear

# solo con 2 argomenti viene ritornato solo lo stato finale
# e non occorre ripulire con pg_result -clear
# Es:
#       set query "select count(*) as tupnum from tablename"
#	set ris [query_exec $dbname $query]

global pgrdVar
	set dbhandle $pgrdVar($dbname,lconn)
	#set lfout $pgrdVar(pgrdlog)
	#puts $lfout "[clock clicks] ($dbname) $query..."
	set res [pg_exec $dbhandle $query]
	set ris [pg_result $res -status]
	set err [pg_result $res -error]
	if {[string length $err]!=0} {
		#puts $lfout "[clock clicks] ($dbname) ...$ris - $err"
		pg_result $res -clear
		return -code error "$err"
		} else {
		#puts $lfout "[clock clicks] ($dbname) ...$ris"
		if {[string length $risp]!=0} {
			return $res
			} else {
			pg_result $res -clear
			return $ris
			}
		}
	
	}



