#-----------------------------------------------
#               FILES   PROPAGATION
#-----------------------------------------------

# propagationOUT:
# run from localhost to export local flows to other sites

# sendData:
# remote file copy procedure

# propagationIN:
# unzip and untar received remote flows archives




#-----------------------------------------------
proc sendData { dbname absfname rhost } {
global pgrdVar

set lfout $pgrdVar(pgrdlog)
set ldbfout $pgrdVar($dbname,pgrdlog)
set FatalErrors [list "Permission denied" "No such file or directory"]

set now "        "

puts $ldbfout "$now [clock clicks] sendData $absfname to $rhost in "


if {![info exists pgrdVar(rcc)]} {
	set pgrdVar(rcc) rcp
	}

switch $pgrdVar(rcc) {
	rcp {set sendCmd "rcp -p $absfname $rhost:$pgrdVar($dbname,inbox)"}
	scp {set sendCmd "scp -pqB $absfname $rhost:$pgrdVar($dbname,inbox)"}
	default {set sendCmd "rcp -p $absfname $rhost:$pgrdVar($dbname,inbox)"}
	}

puts -nonewline $ldbfout "$now [clock clicks] $pgrdVar(rcc) $absfname  -->  $rhost:$pgrdVar($dbname,inbox) ..."
if { [catch {eval exec $sendCmd} msg]} {
	foreach ErrElement  $FatalErrors {
		#puts $ldbfout "$ErrElement: [string first $ErrElement $msg]" 
		if {[string first $ErrElement $msg]>-1} {
			# Error is fatal. Blocking
			return -code error $msg
		        }
                }


	}

puts $ldbfout "sendData: $pgrdVar(rcc) - $msg"
puts $ldbfout "Done"



puts $ldbfout "$now [clock clicks] sendData $absfname to $rhost out "

return $absfname
}
#-----------------------------------------------




#-----------------------------------------------
proc propagationOUT {dbname what} {

global pgrdVar
set lfout $pgrdVar(pgrdlog)
set lhost $pgrdVar($dbname,lhost)
set ldbfout $pgrdVar($dbname,pgrdlog)


set now [clock format [clock second] -format %T]
puts $ldbfout [format "$now [clock clicks] Propagation OUT\t$dbname\t$what"]


set now "        "

#puts $ldbfout  "[clock clicks] starting..."

#set curDir [pwd]
cd $pgrdVar($dbname,outbox)
#puts $lfout "sono in $pgrdVar($dbname,outbox)"



# definisco send_list
# send_list e' del tipo: fname1 host1 fname2 host2 ...
set send_list {}


switch $what {

# pgrdVar($dbname,$host,tables2resolv) 	mi da per ciascun host la lista delle tabelle
#					sulle quali questi applichera' il resolver

# $hosts = $lhost $rhosts

# pgrdVar($dbname,$lhost,tables2resolv)	sono gia' presenti localmente: 
#					mi aspetto di ricevere i flussi remoti per risolverli,
#					devo rispedirli risolti agli rhost che li aspettano
# pgrdVar($dbname,$rhost,tables2resolv) devo mandare i miei flussi per farli risolvere:
#					mi aspetto di riceverli risolti


	2resolv_sites {


		# determiniamo per ciascun resolv_host remoto quali flow_files trasferire.
		# let's define flow_files to transfer for each remote resolv_host
		puts $ldbfout "$now [clock clicks] $dbname,rhosts: $pgrdVar($dbname,rhosts)"
		foreach rhost $pgrdVar($dbname,rhosts) {
			
			puts $ldbfout "$now [clock clicks] Validating $rhost as resolv host..."

			# verifico che sia un resolv_host
			# is rhost a resolv_host?
			if {[info exists pgrdVar($dbname,$rhost,tables2resolv)]} {

				puts $ldbfout "$now [clock clicks] $rhost is a resolv host on - $pgrdVar($dbname,$rhost,tables2resolv) -"

				set flow_files($rhost) {}

				# trovo la lista dei flow_files2resolv
				# let's find flow_files2resolv list
				foreach table2resolv $pgrdVar($dbname,$rhost,tables2resolv) {
					set flow_file  ${lhost}_${dbname}_${table2resolv}_flow
					set absflow_file [file join $pgrdVar($dbname,outbox) $flow_file]
			                if {[file exists $absflow_file]} {
			                        lappend flow_files($rhost) $flow_file
                        			}
					} ;# end of foreach table2resolv

				# creo l'archivio da trasferire a rhost
				# let's create the tarball to transfer to rhost
			        if {[llength $flow_files($rhost)]>0} {
					set archive ${rhost}_${lhost}_${dbname}.tgz
					set absfname [file join $pgrdVar($dbname,outbox) $archive]
                			puts $ldbfout "        [clock clicks] creating  $archive  with  $flow_files($rhost)" 
	                		if {[catch {eval exec tar cvzf $archive $flow_files($rhost)} errmsg]} {
        	                		puts $ldbfout "$now [clock clicks] ERROR while creating $archive: $errmsg" 
                	        		return -code error $errmsg
                        			} else {
                        			puts $ldbfout "$now [clock clicks] created $archive"
						lappend send_list $absfname $rhost
	                        		}
	                		}

				} ;# end of if [info exists...

			} ;# end of foreach rhost

		} ;# end of 2resolv_sites



	resolved_flows {
		# determiniamo per ciascun host remoto quali resolved_flow_files trasferire
		# let's define resolved_flow_files to transfer for each remote host
                foreach rhost $pgrdVar($dbname,rhosts) {

                        # verifico che debba ricevere almeno una tabella
			# let's check remote host tables
                        if {[info exists pgrdVar($dbname,$rhost,tables)]} {

				puts $ldbfout "$now [clock clicks] $rhost tables: $pgrdVar($dbname,$rhost,tables)"

				set res_flow_files($rhost) {}

                                # trovo la lista dei resolved_flow_files
				# let's find resolved_flow_files list
				if {[info exists pgrdVar($dbname,$lhost,tables2resolv)]} {
	                                foreach table2resolv $pgrdVar($dbname,$lhost,tables2resolv) {
						# se rhost ha table2resolv come tabella condivisa devo mandargli il resolved_flow_file
						if {[lsearch -exact $pgrdVar($dbname,$rhost,tables) $table2resolv]>=0} {
	                	                        set res_flow_file  res_${lhost}_${dbname}_${table2resolv}_flow
        	                	                set res_flow_file_abs [file join $pgrdVar($dbname,outbox) $res_flow_file]
                	                	        if {[file exists $res_flow_file_abs]} {
                        	                	        lappend res_flow_files($rhost) $res_flow_file
                                	                	}
							} ;# end of if [lsearch ...
		                                } ;# end of foreach table2resolv
					}

                                # creo l'archivio da trasferire a rhost
				# let's create the tarball to transfer to rhost
       	                        if {[llength $res_flow_files($rhost)]>0} {
               	                        set archive res_${rhost}_${lhost}_${dbname}.tgz
                       	                set absfname [file join $pgrdVar($dbname,outbox) $archive]
                               	        puts $ldbfout "        [clock clicks] creating  $archive  with  $res_flow_files($rhost)..."
                                       	if {[catch {eval exec tar cvzf $archive $res_flow_files($rhost)} errmsg]} {
                                                puts $ldbfout "[clock clicks] ERROR while creating $archive: $errmsg"
       	                                        return -code error $errmsg
               	                                } else {
                       	                        puts $ldbfout "$now [clock clicks] $archive created"
                               	                lappend send_list $absfname $rhost
                                       	        }
                                        }




                                } ;# end of if [info exists...

                        } ;# end of foreach rhost

		} ;# end of resolved_flows



	qryengine_errors {

		# mando il file degli errori al sito replicamaster (a meno che non coincida con quello locale)

		set hostmaster $pgrdVar($dbname,replicamaster)
		puts $ldbfout "$now [clock clicks] local host: $lhost   replicamaster: $hostmaster"

		if {[string compare $lhost $hostmaster] !=0} {
			# mando il file errfile ( lhost_dbname_errors )
			set absfname [file join $pgrdVar($dbname,outbox) ${lhost}_${dbname}_errors]
			# comprimo il file
			file delete ${absfname}.gz
			puts $ldbfout "$now [clock clicks] gzip $absfname..."
			if {[catch {eval exec gzip $absfname} errmsg]} {
				puts $ldbfout "$now [clock clicks] gzip $absfname: $errmsg"
				} else {
				set zabsfname ${absfname}.gz
				set send_list [list $zabsfname $hostmaster]
				puts $ldbfout "$now [clock clicks] created $zabsfname to send to $hostmaster"
				}
			}

		} ;# end of qryengine_errors



	default {

		} ;# end of default


	} ;# end of switch




# trasferisco gli archivi indicati in send_list
# send_list e' del tipo: fname1 host1 fname2 host2 ...
puts $ldbfout "$now [clock clicks] send_list (absfname host...): - $send_list -"
while {[llength $send_list]>0} {
	# estraggo la prima coppia fname rhost
	set absfname [lindex $send_list 0]
	set rhost [lindex $send_list 1]

	# chiamo la procedura sendData
	puts $ldbfout "$now [clock clicks] $absfname --> $rhost ..."
	set fname_send_done [sendData $dbname $absfname $rhost]
	puts $ldbfout "$now [clock clicks] ...$fname_send_done sent to $rhost"

	# rimuovo la prima coppia fname rhost da send_list
	set send_list [lreplace $send_list 0 1]
	puts $ldbfout "$now [clock clicks] send_list (absfname host...): $send_list"

	# rimuovo il file trasferito
        file delete $absfname

	} ;# end of while


set now [clock format [clock seconds] -format %T]

#cd $curDir

puts $ldbfout "$now [clock clicks] propagation OUT: End of procedure"


} ;# end of proc


#--------------------------------------------------------------------




proc propagationIN { dbname } {

# in propagationOUT si crea un file.tgz, lo si passa a sendData 
# e poi lo si rimuove;
# attualmente i files vengono trasferiti in sendData con la rcp;
# a destinazione arriva quindi un file.tgz che deve essere scompattato
# e rimosso
# questo e' il compito di propagationIN (IN perche' deve essere eseguito 
# prima di Flushin)


global pgrdVar
set lfout $pgrdVar(pgrdlog)
set lhost $pgrdVar($dbname,lhost)
set ldbfout $pgrdVar($dbname,pgrdlog)

set now [clock format [clock second] -format %T]
puts $ldbfout [format "$now [clock clicks] Propagation IN\t$dbname"]


#set curDir [pwd]

# cerco in $PGRBOX/dbname/in files da scompattare (.tgz o .gz)

cd $pgrdVar($dbname,inbox)
set tgz_list [split [glob -nocomplain -- *.tgz] { }]
puts $ldbfout "$now [clock clicks] tgz_list: $tgz_list"

# extract lofiles from tgz_list
# they must be uncompressed in LO_import procedure
set lotgz_list [split [glob -nocomplain -- *lofiles.tgz] { }]
puts $ldbfout "$now [clock clicks] lotgz_list: $lotgz_list"
foreach lofile $lotgz_list {
        set ind [lsearch -exact $tgz_list $lofile]
        set tgz_list [lreplace $tgz_list $ind $ind]
	}
puts $ldbfout "$now [clock clicks] tgz_list: $tgz_list"

foreach tgz_file $tgz_list {
        puts $ldbfout "$now [clock clicks] tar xmvzf $tgz_file ..."
        if {[catch {eval exec tar xmvzf $tgz_file} errmsg]} {
        # il tar ritorna lo stato di errore 1 quando estrae un file con data futura
        # il file viene estratto comunque senza problemi
        # il messaggio di warning e':
        # tar: L'archivio contiene l'orario futuro ...
        # cerco 'futuro' nel messaggio per vedere se mi trovo in questa situazione di non-errore
                if {[string first futuro $errmsg]<0} {
                        puts $ldbfout "$now [clock clicks] $errmsg "
                        return -code error "$errmsg"
                        }
                }
	# rimuovo il file.tgz
	puts $ldbfout "$now [clock clicks] deleting $tgz_file..."
        file delete $tgz_file
	set tgz_list [split [glob -nocomplain -- *.tgz] { }]
	puts $ldbfout "$now [clock clicks] tgz_list: $tgz_list"
        }


set now [clock format [clock second] -format %T]
set gz_list [split [glob -nocomplain -- *.gz] { }]
puts $ldbfout "$now [clock clicks] gz_list: $gz_list"
foreach gz_file $gz_list {
        puts $ldbfout "$now [clock clicks] gunzip $gz_file ..."
	if {[file exists $gz_file]} {
		set file [string trimright $gz_file .gz]
		file delete $file
		}
        if {[catch {eval exec gunzip $gz_file} errmsg]} {
                puts $ldbfout "$now [clock clicks] $errmsg "
                return -code error "$errmsg"
                }

        # rimuovo il file.gz
	puts $ldbfout "$now [clock clicks] deleting $gz_file..."
        file delete $gz_file
	set gz_list [split [glob -nocomplain -- *.gz] { }]
	puts $ldbfout "$now [clock clicks] gz_list: $gz_list"
        }



#cd $curDir

puts $ldbfout "$now [clock clicks] propagation IN: End of procedure"

	}






# ---------- END OF FLOW PROPAGATION -----------


