#----------------------------------------------------------
#	AGGIORNA LE TABELLE DEI FLUSSI E QUELLE REPLICATE
#----------------------------------------------------------



# Version 1.10.2

proc update_tables_fwd {dbname} {
global pgrdVar
set lfout $pgrdVar(pgrdlog)
set lhost $pgrdVar($dbname,lhost)
set ldbfout $pgrdVar($dbname,pgrdlog)


set now [clock format [clock second] -format %T]
puts $ldbfout "$now [clock clicks] query_engine $dbname"


# run query_engine to update user's tables
foreach table $pgrdVar($dbname,$lhost,tables) {

        # rollback local rejected operations 
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] local users rejected operations rollback: query_engine $dbname $table local rejected back..."
        query_engine $dbname $table local rejected back
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] ...Done"

        # forwarding remote accepted operations
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] remote users passed operations submitting: query_engine $dbname $table remote passed forward..."
        query_engine $dbname $table remote passed forward
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] ...Done"


        } ;# end of foreach table


}

#///////////////////////////////////////////////


proc update_tables_test {dbname} {
global pgrdVar
set lfout $pgrdVar(pgrdlog)
set lhost $pgrdVar($dbname,lhost)
set ldbfout $pgrdVar($dbname,pgrdlog)


set now [clock format [clock second] -format %T]
puts $ldbfout "$now [clock clicks] query_engine $dbname"


# run query_engine to roll back local replicator's operations
foreach table $pgrdVar($dbname,$lhost,tables) {

        # rollback local replicator operations
        set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] local replicator rollback: query_engine $dbname $table local replicator back..."
        query_engine $dbname $table local replicator back
        set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] ...Done"

        } ;# end of foreach table


}


#///////////////////////////////////////////////

proc update_tables_rew {dbname} {
global pgrdVar
set lfout $pgrdVar(pgrdlog)
set lhost $pgrdVar($dbname,lhost)
set ldbfout $pgrdVar($dbname,pgrdlog)


set now [clock format [clock second] -format %T]
puts $ldbfout "$now [clock clicks]  update_tables_rew IN for  $dbname"

# lancia query_engine per ripristinare lo stato delle tabelle
# sequence of operations during Synchronization:
# 1   local users rejected operations rollback
# 2   remote users passed operations submitting
# 3   large object links update

# so for rollback the sequence wiil be:
# 1   large object update rollback
# 2   (committed) remote users passed back
# 3   local users rejected forward



# large object update rollback
set now [clock format [clock second] -format %T]
if {[catch {LO_update_back $dbname} errmsg]} {
	puts $ldbfout "$errmsg"
	puts $ldbfout "$now [clock clicks] Let us pray :("
	} else {
	puts $ldbfout "$now [clock clicks] ...Done"
	}



foreach table $pgrdVar($dbname,$lhost,tables) {

	set flowtable ${table}_flow
	set lsite $pgrdVar($dbname,lsite)

	# pone a 'N' il flag di table_flow per le operazioni remote accettate non presenti in pgr_qryengine_log
	# (cioe' non ancora eseguite e quindi da non sottoporre al rollback)
	set query "update $flowtable set pgr_flow_flag = \'N\' where pgr_sid_f(pgr_gfid)!=$lsite and pgr_flow_flag = \'Y\' and pgr_gfid not in (select pgr_gfid from pgr_qryengine_log where tablename = \'$table\')"
        puts $ldbfout  "$now [clock clicks] $query..."
        set ris [query_exec $dbname $query]
	set now [clock format [clock second] -format %T]
        puts $ldbfout  "$now [clock clicks] ...$ris"

	# pone a 'N' il flag di table_flow per le operazioni remote accettate ma che hanno dato errore in pgr_qryengine_log
	# (non essendo state eseguite non vanno ripristinate)
	set query "update $flowtable set pgr_flow_flag = \'N\' where pgr_sid_f(pgr_gfid)!=$lsite and pgr_flow_flag = \'Y\' and  pgr_gfid in (select pgr_gfid from pgr_qryengine_log where tablename = \'$table\' and qry_result!=\'\')"
	set now [clock format [clock second] -format %T]
        puts $ldbfout  "$now [clock clicks] $query..."
        set ris [query_exec $dbname $query]
	set now [clock format [clock second] -format %T]
        puts $ldbfout  "$now [clock clicks] ...$ris"


	# suppongo che non ci siano stai errori durante il rollback delle operazioni locali con flow_flag = N


        # rollback locale operazioni remote con flow_flag = Y
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] rollback op. remote: query_engine $dbname $table remote passed back..."
        query_engine $dbname $table remote passed back
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] ...Done"


        # ripristino operazioni locali con flow_flag = N
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] ripristino op. locali: query_engine $dbname $table local rejected forward..."
        query_engine $dbname $table local rejected forward
	set now [clock format [clock second] -format %T]
        puts $ldbfout "$now [clock clicks] ...Done"

	

        } ;# end of foreach table

	# ripristino le tabelle dei flussi iniziali
	reset_flows $dbname

}





#///////////////////////////////////////////////
#///////////////////////////////////////////////

