proc setup { } {
global pgrdVar 

   # replica directories

	# check for PGRBIN 
        if {![info exists pgrdVar(PGRBIN)]} {
                puts stderr "Environment variable PGRBIN needed"
                puts stderr "Is ReplicaTools properly installed ?"
                return -1
                } else {
                set pgrdVar(pgrd_HOME) $pgrdVar(PGRBIN)
                }
        set pgrdVar(pgrd_resolv) [file join $pgrdVar(pgrd_HOME) resolvers]
        set pgrdVar(pgrd_proc) [file join $pgrdVar(pgrd_HOME) procedures]

	# check for PGRDATA
	if {![info exists pgrdVar(PGRDATA)]} {
		return -code error "Environment variable PGRDATA needed"
		} else {
		set pgrdVar(pgrd_DATA) $pgrdVar(PGRDATA)
		set pgrdVar(pgrd_LOG) $pgrdVar(PGRDATA)/log 
		}

	# check for PGRBOX
	if {![info exists pgrdVar(PGRBOX)]} {
		return -code error "Environment variable PGRBOX needed"
		} else {
		set pgrdVar(pgrd_BOX) $pgrdVar(PGRBOX) 
		}


        # ports

        # postgres		5432
        # tcl_dp		5430
        # data socket 		5431

	# check for PG_PORT
	if {![info exists pgrdVar(PG_PORT)]} {
		return -code error "Environment variable PG_PORT needed"
		} else {
		set pgrdVar(pg_port) $pgrdVar(PG_PORT) 
		}

	# check for RPC_PORT
	if {![info exists pgrdVar(RPC_PORT)]} {
		return -code error "Environment variable RPC_PORT needed"
		} else {
		set pgrdVar(rpc_port) $pgrdVar(RPC_PORT) 
		}

	# check for DATA_PORT
	if {![info exists pgrdVar(DATA_PORT)]} {
		return -code error "Environment variable DATA_PORT needed"
		} else {
		set pgrdVar(data_port) $pgrdVar(DATA_PORT) 
		}

	
	# language
	if {[info exists pgrdVar(LANGUAGE)]} {
		set pgrdVar(language) $pgrdVar(LANGUAGE)
		}

	# Remote Copy Command
	if {[info exists pgrdVar(RCC)]} {
		set pgrdVar(rcc) $pgrdVar(RCC)
		}

	# version
	set pgrdVar(version) [exec cat [file join $pgrdVar(pgrd_HOME) VERSION]]
}

