#!/bin/sh
# the next line restart using pgtclsh \
exec pgtclsh "$0" "$@"


# Usage: getdata <dbname> <tablename> <from_tablename>


# extract data from from_tablename into tablename 
# and drop tablename;
# only data from common attributes is extracted!



if ($argc!=3) {
	puts "Usage: getdata <dbname> <tablename> <from_tablename>"
	return -1
	}

set dbname [lindex $argv 0]
set tablename [lindex $argv 1]
set fromtablename [lindex $argv 2]


if {[catch {pg_connect $dbname} dbhandle]} {
	puts stderr $dbhandle
	return -code error $dbhandle
	}

#puts "dbhandle: $dbhandle"


catch {unset attarray}
set query "select attname from pg_attribute where attrelid = (select oid from pg_class where relname = \'$tablename\') and attnum>0"
set res [pg_exec $dbhandle $query]
pg_result $res -assign attarray
pg_result $res -clear

set newattlist {}
foreach name [lsort [array names attarray]] { 
	#puts "$name: $attarray($name)"
	lappend newattlist $attarray($name)
	}
#puts [format "newattlist: \n$newattlist"]

catch {unset attarray}
set query "select attname from pg_attribute where attrelid = (select oid from pg_class where relname = \'$fromtablename\') and attnum>0"
set res [pg_exec $dbhandle $query]
pg_result $res -assign attarray
pg_result $res -clear

set oldattlist {}
foreach name [lsort [array names attarray]] {
        #puts "$name: $attarray($name)"
        lappend oldattlist $attarray($name)
        }
#puts [format "oldattlist: \n$oldattlist"]

set sameattlist {}
set sameattstring ""
foreach newatt $newattlist {
	if {[lsearch $oldattlist $newatt]!=-1} {
		lappend sameattlist $newatt
		append sameattstring $newatt,
		}
	}

set sameattstring [string trimright $sameattstring ,]
#puts [format "sameattlist: \n$sameattlist"]


set query "insert into $tablename ( $sameattstring ) select $sameattstring from $fromtablename"
puts "$query..."
set res [pg_exec $dbhandle $query]
set ris [pg_result $res -error]
pg_result $res -clear
puts "...$ris"
if {[string compare $ris ""]!=0} {
	pg_disconnect $dbhandle
	return -code error $ris
	}



set query "drop table $fromtablename"
puts "$query..."
set res [pg_exec $dbhandle $query]
set ris [pg_result $res -error]
pg_result $res -clear
puts "...$ris"
if {[string compare $ris ""]!=0} {
	pg_disconnect $dbhandle
        return -code error $ris
        }


pg_disconnect $dbhandle


